//dojo.require("dojo.data.ItemFileReadStore");
//dojo.require("dojo.data.ItemFileWriteStore");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.form.Form");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.FilteringSelect");
dojo.require("dijit.form.Select");
dojo.require("dijit.form.NumberTextBox");
dojo.require("dijit.form.CurrencyTextBox");
dojo.require("dijit.form.DateTextBox");
dojo.require("dijit.form.ValidationTextBox");
dojo.require("dijit.form.SimpleTextarea");
dojo.require("dijit.form.Textarea");
dojo.require("dijit.form.TextBox");
//dojo.require("dijit.form.CheckBox");
dojo.require("dijit.Dialog");
dojo.require("dojo.parser");
// Custom el.: ValidationTextarea ON

// validation controls ON
// ИНН
dojo.provide("ValidationTextBoxINN");
dojo.declare(
        "ValidationTextBoxINN",
        [dijit.form.ValidationTextBox],
        {
            regExp: "^\\d{10}$",
            errorMessage: 'Некорректный ИНН.',
            onFocus: function() {
                var errMsg = (this.value != '' || this.required) ? validateINN(this.attr('value')) : null;
                if (errMsg) {
                    this.set("state", "Error");
                    this.displayMessage(errMsg);
                    this._setStateClass();
                }
            }
            ,
            onBlur: function() {
                //if (this.required || this.value != '') {
                var errMsg = (this.value != '' || this.required) ? validateINN(this.attr('value')) : null;
                if (errMsg) {
                    this.set("state", "Error");
                    this.displayMessage(errMsg);
                    this._setStateClass();
                }
                //}
            }
            ,
            isValid: function() {
                var isValid = true;
                //if (this.value != '') {
                var errMsg = (this.value != '' || this.required) ? validateINN(this.attr('value')) : null;
                if (errMsg) {
                    isValid = false;
                }
                //}
                return isValid;
            }

        }
);

// КПП
dojo.provide("ValidationTextBoxKPP");
dojo.declare(
        "ValidationTextBoxKPP",
        [dijit.form.ValidationTextBox],
        {
            regExp: "^\\d{9}$",
            invalidMessage: 'КПП должен состоять из 9 цифр.',
            errorMessage: 'КПП должен состоять из 9 цифр.',
            onBlur: function() {
                var errMsg = (this.value != '' || this.required) ? validateKPP(this.attr('value')) : null;
                if (errMsg) {
                    this.set("state", "Error");
                    this.displayMessage(errMsg);
                    this._setStateClass();
                }
            }
            ,
            isValid: function() {
                var isValid = true;
                var errMsg = (this.value != '' || this.required) ? validateKPP(this.attr('value')) : null;
                if (errMsg) {
                    var isValid = false;
                }
                return isValid;
            }
        }
);
// СНИЛС
dojo.provide("ValidationTextBoxSnils");
dojo.declare(
        "ValidationTextBoxSnils",
        [dijit.form.ValidationTextBox],
        {
            regExp: "^\\d{11}$",
            onBlur: function() {
                if (this.attr('value') != '') {
                    var errMsg = (this.value != '' || this.required) ? validateSnils(this.attr('value')) : null;
                    if (errMsg) {
                        this.set("state", "Error");
                        this.displayMessage(errMsg);
                        this._setStateClass();
                    }
                }
            }
            ,
            isValid: function() {
                var isValid = true;
                var errMsg = (this.value != '' || this.required) ? validateSnils(this.attr('value')) : null;
                if (errMsg) {
                    var isValid = false;
                }
                return isValid;
            }
        }
);

// РЕГ.НОМЕР
dojo.provide("fssExt.RegNumField");
dojo.declare(
    "fssExt.RegNumField",
    [dijit.form.ValidationTextBox],
    {
        regExp: "^\\d{10}$",
        invalidMessage: 'РЕГ.НОМЕР должен состоять из 10 цифр.',
        errorMessage: 'РЕГ.НОМЕР должен состоять из 10 цифр.'
    }
);

dojo.provide("fssExt.OkvedField");
dojo.declare(
        "fssExt.OkvedField",
        [dijit.form.ValidationTextBox],
        {
            invalidMessage: 'Правильный формат ОКВЭД: XX.XX.XX',
            regExp: '^([0][1-9]|[1-9][0-9])(\\.([0-9]|[0-9][0-9]))?(\\.([0-9]|[0-9][0-9]))?'
        }
);
//
// ОГРН
dojo.provide("ValidationTextBoxOgrn");
dojo.declare(
        "ValidationTextBoxOgrn",
        [dijit.form.ValidationTextBox],
        {
            regExp: "^\\d{13}|^\\d{15}$",
            onFocus: function() {
                if (this.value != '') {
                    var errMsg = validateOgrn(this.attr('value'));
                    if (errMsg) {
                        this.set("state", "Error");
                        this.displayMessage(errMsg);
                        this._setStateClass();
                    }
                }
            }
            ,
            onBlur: function() {
                if (this.value != '') {
                    var errMsg = validateOgrn(this.attr('value'));
                    if (errMsg) {
                        this.set("state", "Error");
                        this.displayMessage(errMsg);
                        this._setStateClass();
                    }
                }
            }
            ,
            isValid: function() {
                var isValid = true;
                var errMsg = (this.value != '' || this.required) ? validateOgrn(this.attr('value')) : null;
                if (errMsg) {
                    var isValid = false;
                }
                return isValid;
            }
        }
);


// ОГРН
function validateOgrn(value) {
    if (isNaN(value) || !value || (value.length != 13 && value.length != 15)) {
        return 'ОГРН должен состоять из 13 или 15 цифр.';
    }

    var errIncorrect = "Некорректный ОГРН"

    if (value.length == 13) {
        var number13 = parseInt(value.slice(0, -1));
        var last13 = parseInt(value.slice(-1));
        var ost13 = parseInt((number13 % 11).toString().slice(-1));
        if (last13 != ost13)
            return errIncorrect;
    }

    if (value.length == 15) {
        var number15 = parseInt(value.slice(0, -1));
        var last15 = parseInt(value.slice(-1));
        var ost15 = parseInt((number15 % 13).toString().slice(-1));
        if (last15 != ost15)
            return errIncorrect;
    }
}
//
dojo.provide("fssExt.ValidationTextarea");
dojo.declare(
        "fssExt.ValidationTextarea",
        [dijit.form.ValidationTextBox, dijit.form.Textarea],
        {
            regExp: "(.|\\s)*", // Important!
            postCreate: function() {
                this.inherited(arguments);
            },
            validate: function() {
                this.inherited(arguments);
                if (arguments.length == 0)
                    this.validate(false);
            },
            validate: function(isFocused) {
                if (arguments.length == 0) {
                    return this.validate(false);
                }
                return this.inherited(arguments);
            },
                    onFocus: function() {
                        this.validate();  // V 1.5
                        if (!this.isValid()) {
                            this.displayMessage(this.getErrorMessage());  // V 1.5 important
                            //this.displayErrorMessage();  // V 1.6
                        }
                    },
            onBlur: function() {
                if (!this.isValid()) {
                    this.displayMessage(this.getErrorMessage());  // V 1.5
                    //this.displayErrorMessage();  // V 1.6
                }
            }

        });



//Custom: Percent NumberTextBox
//dojo.provide("fss.PercNumberTextBox");
dojo.declare(
        "fss.PercNumberTextBox", dijit.form.NumberTextBox,
        {
            //myconstraints:{min:0,max:99,places:'0,1'},
            invalidMessage: "Недопустимое значение. Формат ввода – число с одним знаком после запятой (Пример: 99,1)"
                    //        ,postCreate:function(){
                    //           this.constraints = this.myconstraints;
                    //        }
        });


dojo.declare(
        "dijit.form.CurrencyTextBox", dijit.form.CurrencyTextBox,
        {
            invalidMessage: "Недопустимое значение. Формат ввода – число с двумя знаками после запятой (Пример: 100,10)"
        });


dojo.extend(dijit.form.FilteringSelect, {
    resetOptions: function() {
        var dij = this;
        this.store.fetch({
            query: {
                name: '*'
            },
            onComplete: function(items) {
                dij.set('value', items[0].value)
            }
        });
    }
});

//
//
Array.prototype.unique = function() {
    var a = this.concat();
    for (var i = 0; i < a.length; ++i) {
        for (var j = i + 1; j < a.length; ++j) {
            if (a[i].orgid === a[j].orgid)
                a.splice(j--, 1);
        }
    }
    return a;
}
//
Array.prototype.contains = function(obj) {
    var i = this.length;
    while (i--) {
        if (this[i] == obj) {
            return true;
        }
    }
    return false;
}

Array.prototype.clean = function(deleteValue) {
  for (var i = 0; i < this.length; i++) {
    if (this[i] == deleteValue) {
      this.splice(i, 1);
      i--;
    }
  }
  return this;
};
//

var calReadOnly = true;
// Custom el.: ValidationTextarea OFF
// util methods!!!
function sc(obj, clr) {
    obj.style.backgroundColor = clr;
}
var loaderImg = vc_getAppUri + "/img/ajax-loader.gif";
function getContextPath() {
    //return "\$vc.cp()";
    return vc_cp;
}
function getCp() {
    //return "$vc.cp()";
    return vc_cp;
}
function reloadPage() {
    document.location.href = getCp();
}
function getAuthErr() {
    //return "$vc.getAuthErr()";
    return vc_getAuthErr;
}
function getLoadImg() {
    return getContextPath() + loaderImg;
}
function showLoadIndicator(divId, iSrc) {
    dijit.byId(divId).attr('content', '<image src="' + iSrc + '">');
}
function clearLoadIndicator(divId) {
    dijit.byId(divId).attr('content', '');
}
//
function getTabPane(tId) {
    return dijit.byId(tId);
}
function refreshTabPane() {
    getCTabPane().refresh();
}
function setCurTabPane(tId, aUri) {
    var curTabPane = getTabPane(tId);
    curTabPane.attr('href', aUri);
}
//

function removeSelOnCurTab(tabsCount) {
    var cTabId = 0;
    try {
        for (i = 0; i <= tabsCount; i++) {
            var elem = dojo.query("#lit" + i);
            if (elem)
                if (elem.attr("class") == 'aTab') {
                    cTabId = i;
                    elem.removeClass("aTab");
                    break;
                }
        }
    } catch (e) {
    }
    //alert(cTabId);
    return cTabId;
}

/**
 * Получить индекс выбранной закладки
 * @param tabsCount число закладок - 1 (так уж сделано)
 * @returns {number} номер выбранной активной закладки, начиная с 1
 */
function getSelectedTab(tabsCount) {
    var cTabId = 0;
    try {
        for (i = 0; i <= tabsCount; i++) {
            var elem = dojo.query("#lit" + i);
            if (elem)
                if (elem.attr("class") == 'aTab') {
                    cTabId = i;
                    break;
                }
        }
    } catch (e) {
    }
    //alert(cTabId);
    return cTabId;
}
//
function onLatestFormTab(tId, type, mode, tabsCount, version) {
    var bN = dijit.byId("formNextBtn");
    var bA = dijit.byId("formAcceptBtn");
    var bS = dijit.byId("formSaveBtn");
    var bP = dijit.byId("printBtn");
    var bXML = dijit.byId("toXMLBtn");
    var bV = dijit.byId("validateBtn");
    var authInt;

    if (type == 'F4' || type == 'F4A') {
        authInt = 1;
    } else {
        authInt = 0;
    }

    if (bA) {
        bA.attr('disabled', false);
    }
    if (bS) {
        bS.attr('disabled', false);
    }
    if (bP) {
        bP.attr('disabled', false);
    }
    if (bV) {
        bV.attr('disabled', false);
    }
    if (bXML) {
        bXML.attr('disabled', false);
    }
    if (bN) {
            bN.domNode.style.visibility = "";
            bN.focus();
    }
}
//
function formViewTab(tId, ctId) {
    formTab(tId, ctId, '', "view");
}
//
function formTab(tId, ctId, type, mode, tabsCount, currentOrg, version) {
    //
    var selTab = ctId ? ctId : getSelectedTab(tabsCount);
    if (tId < selTab || isValidCurTab(tabsCount, selTab)) {
        if (!ctId)
            ctId = removeSelOnCurTab(tabsCount);

        //postTab(tId,ctId,auth,mode,currentOrg);
        postTab(tId, ctId, type, mode, currentOrg, version);

        // select cur tab
        var elem1 = dojo.query("#lit" + tId);
        //alert(elem1);
        if (elem1)
            elem1.addClass("aTab");
        var elm = document.getElementById('selectedTab');
        if (elm) {
            elm.value = tId;
        }
        //latest tab detect
        onLatestFormTab(tId, type, mode, tabsCount, version);
        // tablePaneOnLoad1(tId);
        //setCurTabPane('contentTable',getActionUri('services/formfour-t?t=t'+tId));
    }
}
//
//TODO: refactor validation next tab
function formNextTab(type, tabsCount, mode, current_org, version) {
    if (isValidCurTab(tabsCount, getSelectedTab(tabsCount))) {
        var cTabId = removeSelOnCurTab(tabsCount);
         var nextTabs = {
         1: 2, 2: 3, 3: 4, 4: 5, 5: 7, 7: 8, 8: 9, 9: 10, 10: 11, 11: 12, 12: 13, 13: 14, 14: 1
         };
         var nextTab = nextTabs[cTabId];
         if (nextTab == null) {
         nextTab = 1;
         }
         formTab(nextTab, cTabId, type, mode, tabsCount, current_org, version);
    }
//if(isValidCurTab(cTabId))formTab(cTabId+1,cTabId,auth,'',tabsCount);
}

function isValidTab7() {
    var isValid = true;
    var firstInvalidId;
    var dijs = dijit.findWidgets(dojo.byId('table45Container'));
    dojo.forEach(dijs, function(dij) {
        try {
            if (!dij.isValid()) {
                //dij.validate()
                dij.set("state", "Error");
                dij._setStateClass();
                if (!firstInvalidId || firstInvalidId == '') {
                    firstInvalidId = dij.id;
                }
                isValid = false;
            }
        } catch (e) {
            //alert(e)
        }
    });
    if (firstInvalidId) {
        if (!firstInvalidId.match(/c1/g)) {
            var errDij = dijit.byId(firstInvalidId);
            errDij.displayMessage(errDij.getErrorMessage());
        }
        //dijit.showTooltip(errDij.get("invalidMessage"),errDij.domNode,'above');
        //dijit.showTooltip(errDij.getErrorMessage(),errDij.domNode,'above');
    }
    return isValid;
    //return false;
}

/**
 * Проверка числа закладок на страничке ввода формы 4.
 * Каждый раз при создании новой закладки следует обновлять эту функцию?
 * @param tabsCount число закладок
 * @param tId идентификатор закладки
 * @returns {boolean|*} true если всё нормально, иначе false
 */
function isValidF4InputCurrentTab(tabsCount, tId) {
    return (tabsCount == 15) && dijit.byId('reportForm').validate();
}

function isValidCurTab(tabsCount, tId) {
//    if (tabsCount == 13 || tabsCount == 14 || tabsCount == 15) {
    if (tabsCount > 12 && tabsCount < 16) {
        //if (tId == '5' || tId == '7' || tId == '9' || tId == '12' || tId == '13') {

        /*if (tId == '5' || tId == '9' || tId == '12' || tId == '13') {
            return true;
        } else if (tId == '7') {
            //return isValidTab7()
            //TEMP
            return true;
        }*/

        if (!dijit.byId('reportForm').validate()) {
            return false;
        }
        else {
            return true;
        }
    } else if (tabsCount == 4) {
        if (!dijit.byId('reportForm').validate()) {
            return false;
        }
    } else if (tabsCount == 16) {
        if (tId == '5' || tId == '10' || tId == '13' || tId == '14') {
            return true;
        }
        if (!dijit.byId('reportForm').validate()) {
            return false;
        }
        else {
            return true;
        }
    }
    return true;
}

function postTab(tId, ctId, type, mode, currentOrg, version) {
    showLoadIndicator('loadP', getLoadImg());
    var actionPrefix = "";
    /*
     if (auth) {
     actionPrefix = "services/formfour-t";
     } else {
     actionPrefix = "f4input-t";
     }
     */
    if (type == 'F4') {
        actionPrefix = "services/formfour-t";
    }
    else if (type == 'F4A') {
        actionPrefix = "services/formfour-a-t";
    } else {
        if (type == 'F4_INPUT') {
            actionPrefix = "f4input-t";
        }
    }


    var org = "";
    if (currentOrg) {
        org = "&current_org=" + currentOrg;
    }
    if (mode) {
        standardServerPost('reportForm', 'contentTable', getActionUri(actionPrefix + '?t=t' + tId + "&ct=t" + ctId + "&mode=" + mode + "&h=" + Math.random()) +"&version=" +version);
    } else {
        standardServerPost('reportForm', 'contentTable', getActionUri(actionPrefix + '?t=t' + tId + "&ct=t" + ctId + org + "&h=" + Math.random()) +"&version=" +version);
    }
}

//
function postTabAndSaveForm(tId) {
    showLoadIndicator('loadP', getLoadImg());
    servPost('reportForm', 'contentTable', getActionUri('services/formfour-t?t=t' + tId + "&ct=t" + tId + "&saveForm=1&h=" + Math.random()),
            afterSaveF4, afterSaveF4Error);
}
//
function postTabAndSaveFormFourA(tId) {
    showLoadIndicator('loadP', getLoadImg());
    servPost('reportForm', 'contentTable', getActionUri('services/formfour-a-t?t=t' + tId + "&ct=t" + tId + "&saveForm=1&h=" + Math.random()),
            afterSaveF4A, afterSaveF4AError);
}
//
function afterSaveF4() {
    //alert('afterSaveF4');
    onSaveCompleteFormFour1();
    setTimeout("onSaveCompleteFormFour2()", 1500);
}
function afterSaveF4Error() {
    //alert('afterSaveF4Error');
    onSaveCompleteFormFour1();
    setTimeout("onSaveCompleteFormFour2()", 1500);
}
function afterSaveF4A() {
    //alert('afterSaveF4');
    onSaveCompleteFormFourA1();
    setTimeout("onSaveCompleteFormFourA2()", 1500);
}
function afterSaveF4AError() {
    //alert('afterSaveF4Error');
    onSaveCompleteFormFourA1();
    setTimeout("onSaveCompleteFormFourA2()", 1500);
}

function tablePaneOnLoad() {

    if (!calReadOnly) {
        return;
    }

    var selTab = document.getElementById('selectedTab').value;

    switch (parseInt(selTab)) {

        case 2:
            {
                calc('t2', '');
                //      alert('set!');
                break;
            }
        case 3:
            {
                for (var i = 3; i <= 5; i++) {
                    calc('t3', '' + i);
                }
                break;
            }
        case 4:
            {
                for (var i = 3; i <= 6; i++) {
                    calc('t4', '' + i);
                }
                break;
            }
        case 5:
            {
                for (var i = 5; i <= 8; i++) {
                    calc('t5', '' + i);
                }
                break;
            }
        case 6:
            {
                for (var i = 1; i <= 4; i++) {
                    calc('t6', '' + i);
                }
                break;
            }
        case 7:
            {
                calc('t7', '1');
                break;
            }
        case 8:
            {
                for (var i = 6; i <= 20; i++) {
                    calc('t8', '' + i);
                }
                break;
            }
        case 10:
            {
                for (var i = 3; i <= 9; i++) {
                    calc('t10_1', '' + i);
                }
                calc('t10_2', '');
                break;
            }
        case 11:
            {
                calc('t11_1', '');
                calc('t11_2', '');
                break;
            }
    }

}

function tablePaneOnLoad2012() {
    if (!calReadOnly) {
        return;
    }

    var selTab = document.getElementById('selectedTab').value;

    switch (parseInt(selTab)) {

        case 2:
            {
                calc('t2', '');
                //      alert('set!');
                break;
            }
        case 3:
            {
                for (var i = 3; i <= 5; i++) {
                    calc('t3', '' + i);
                }
                break;
            }
        case 4:
            {
                for (var i = 3; i <= 6; i++) {
                    calc('t4', '' + i);
                }
                break;
            }
        case 5:
            {
                for (var i = 5; i <= 8; i++) {
                    calc('t5', '' + i);
                }
                break;
            }
        case 6:
            {
                for (var i = 3; i <= 6; i++) {
                    calc2012('t6_1', '' + i);
                }
                for (var i = 3; i <= 6; i++) {
                    calc2012('t6_2', '' + i);
                }
                break;
            }
        case 7:
            {
                calc2012('t7_1', '3');
                calc2012('t7_1', '4');
                calc2012('t7_2', '');
                calc2012('t7_3', '3');
                calc2012('t7_3', '4');
                break;
            }
        case 8:
            {
                for (var i = 6; i <= 20; i++) {
                    calc('t8', '' + i);
                }
                break;
            }
        case 10:
            {
                for (var i = 3; i <= 9; i++) {
                    calc('t10_1', '' + i);
                }
                try {
                    calc('t10_2', '');
                } catch (e) {
                    //alert(e);
                }
                break;
            }
        case 11:
            {
                calc('t11_1', '');
                calc('t11_2', '');
                break;
            }
    }

}


function tablePaneOnLoad2014() {
    if (!calReadOnly) {
        return;
    }

    var selTab = document.getElementById('selectedTab').value;

    switch (parseInt(selTab)) {

        case 2:
            {
                calc('t2', '');
                //      alert('set!');
                break;
            }
        case 3:
            {
                for (var i = 3; i <= 5; i++) {
                    calc('t3', '' + i);
                }
                break;
            }
        case 4:
            {
                for (var i = 3; i <= 6; i++) {
                    calc('t4', '' + i);
                }
                break;
            }
        case 5:
            {
                for (var i = 5; i <= 8; i++) {
                    calc('t5', '' + i);
                }
                break;
            }
        case 6:
            {
                for (var i = 3; i <= 6; i++) {
                    calc2012('t6_1', '' + i);
                }
                for (var i = 3; i <= 6; i++) {
                    calc2012('t6_2', '' + i);
                }
                break;
            }
        case 7:
            {
                calc2012('t7_1', '3');
                calc2012('t7_1', '4');
                calc2012('t7_2', '');
                calc2012('t7_3', '3');
                calc2012('t7_3', '4');
                break;
            }
        case 8:
            {
                for (var i = 6; i <= 20; i++) {
                    calc('t8', '' + i);
                }
                break;
            }
        case 10:
            {
                for (var i = 3; i <= 9; i++) {
                    calc('t10_1', '' + i);
                }
                try {
                    calc('t10_2', '');
                } catch (e) {
                    //alert(e);
                }
                break;
            }
        case 11:
            {
                calc('t11_1', '');
                calc('t11_2', '');
                break;
            }
    }

}

function tablePaneOnLoad2015() {
    console.log("tablePaneOnLoad2015");
    if (!calReadOnly) {
        return;
    }

    var selTab = document.getElementById('selectedTab').value;

    switch (parseInt(selTab)) {

        case 2:
        {
            calc2015('t2', '');
            //      alert('set!');
            break;
        }
        case 3:
        {
            for (var i = 3; i <= 5; i++) {
                calc2015t3c3();
                calc2015t3c4();
                calc2015t3c5();
                // calc2015('t3', '' + i);
            }
            break;
        }
        case 4:
        {
            for (var i = 3; i <= 6; i++) {
                calc2015('t4', '' + i);
            }
            break;
        }
        case 5:
        {
            for (var i = 5; i <= 8; i++) {
                calc2015('t5', '' + i);
            }
            break;
        }
        case 6:
        {
            for (var i = 3; i <= 6; i++) {
                calc2015('t6_1', '' + i);//2
            }
            for (var i = 3; i <= 6; i++) {
                calc2015('t6_2', '' + i);//2
            }
            break;
        }
        case 7:
        {
            calc2015('t7_1', '3');
            calc2015('t7_1', '4');
            calc2015('t7_2', '');
            calc2015('t7_3', '3');
            calc2015('t7_3', '4');
            break;
        }
        case 8:
        {
            for (var i = 6; i <= 20; i++) {
                calc2015('t8', '' + i);
            }
            break;
        }
        case 10:
        {
            for (var i = 3; i <= 9; i++) {
                calc2015('t10_1', '' + i);
            }
            try {
                calc2015('t10_2', '');
            } catch (e) {
                //alert(e);
            }
            break;
        }
        case 11:
        {
            calc2015('t11_1', '');
            calc2015('t11_2', '');
            break;
        }
    }

}

function tablePaneOnLoad2016() {
    console.log("tablePaneOnLoad2016");
    if (!calReadOnly) {
        return;
    }

    var selTab = document.getElementById('selectedTab').value;

    switch (parseInt(selTab)) {

        case 2:
        {
            calc2016('t2', '');
            //      alert('set!');
            break;
        }
        case 3:
        {
            for (var i = 3; i <= 5; i++) {
                calc2015t3c3();
                calc2015t3c4();
                calc2016t3c5();
                // calc2015('t3', '' + i);
            }
            break;
        }
        case 4:
        {
            for (var i = 3; i <= 6; i++) {
                calc2016('t4', '' + i);
            }
            break;
        }
        case 5:
        {
            for (var i = 5; i <= 8; i++) {
                calc2016('t5', '' + i);
            }
            break;
        }
        case 6:
        {
            for (var i = 3; i <= 6; i++) {
                calc2016('t6_1', '' + i);//2
            }
            for (var i = 3; i <= 6; i++) {
                calc2016('t6_2', '' + i);//2
            }
            break;
        }
        case 7:
        {
            calc2016('t7_1', '3');
            calc2016('t7_1', '4');
            calc2016('t7_2', '');
            calc2016('t7_3', '3');
            calc2016('t7_3', '4');
            break;
        }
        case 8:
        {
            for (var i = 6; i <= 20; i++) {
                calc2016('t8', '' + i);
            }
            break;
        }
        case 10:
        {
            for (var i = 3; i <= 9; i++) {
                calc2016('t10_1', '' + i);
            }
            try {
                calc2016('t10_2', '');
            } catch (e) {
                //alert(e);
            }
            break;
        }
        case 11:
        {
            calc2016('t11_1', '');
            calc2016('t11_2', '');
            break;
        }
    }

}

function tablePaneOnLoadF4A() {
    if (!calReadOnly) {
        return;
    }

    var selTab = document.getElementById('selectedTab').value;

    calcF4A('t' + selTab);
}
//
function tablePaneOnLoadViewMode() {
    dojo.query("input").forEach(
            function(inputElement) {
                if (inputElement.id != 'prettyXMLFormat' && inputElement.id != 'rstate') {
                    inputElement.disabled = true;
                }
            });
    tablePaneOnLoad();
}

function tablePaneOnLoadViewMode2012() {
    dojo.query("input").forEach(
            function(inputElement) {
                if (inputElement.id != 'prettyXMLFormat' && inputElement.id != 'rstate') {
                    inputElement.disabled = true;
                }
            });
    tablePaneOnLoad2012();
}


function disabledInput() {
    dojo.query("input").forEach(
        function(inputElement) {
            if (inputElement.id != 'prettyXMLFormat' && inputElement.id != 'rstate') {
                inputElement.disabled = true;
            }
        });
}

function tablePaneOnLoadViewModeF4A() {
    dojo.query("input").forEach(
            function(inputElement) {
                if (inputElement.id != 'prettyXMLFormat' && inputElement.id != 'rstate') {
                    inputElement.disabled = true;
                }
            });
    tablePaneOnLoadF4A();
}
// Accept Form Four
function acceptFormFour(tabsCount) {
    var selTab = getSelectedTab(tabsCount);
    if (isValidCurTab(tabsCount, selTab)) {
        var dlg = dijit.byId('saveFormCompleteDlg');
        dlg.show();
        dlg.setContent("");
        //postTabAndSaveForm(selTab);
        showLoadIndicator('loadP', getLoadImg());
        servPost('reportForm', 'contentTable', getActionUri('services/formfour-t?t=t' + selTab + "&ct=t" + selTab + "&saveForm=1&h=" + Math.random()),
                afterAcceptF4, afterAcceptF4Error);
    }
}

function acceptFormFourA(tabsCount) {
    var selTab = getSelectedTab(tabsCount);
    if (isValidCurTab(tabsCount, selTab)) {
        var dlg = dijit.byId('saveFormCompleteDlg');
        dlg.show();
        dlg.setContent("");
        //postTabAndSaveForm(selTab);
        showLoadIndicator('loadP', getLoadImg());
        servPost('reportForm', 'contentTable', getActionUri('services/formfour-a-t?t=t' + selTab + "&ct=t" + selTab + "&saveForm=1&h=" + Math.random()),
                afterAcceptF4A, afterAcceptF4AError);
    }
}

function afterAcceptF4() {
    //alert('afterSaveF4');
    onSaveCompleteFormFour1();
    //tsetTimeout("onAcceptCompleteFormFour2()", 1500);
    setTimeout("onAcceptCompleteFormFour2()", 1500);
}
function afterAcceptF4Error() {
    //alert('afterSaveF4Error');
    onSaveCompleteFormFour1();
    setTimeout("onAcceptCompleteFormFour2()", 1500);
}

function afterAcceptF4A() {
    //alert('afterSaveF4');
    onSaveCompleteFormFourA1();
    setTimeout("onAcceptCompleteFormFour2()", 1500);
}
function afterAcceptF4AError() {
    //alert('afterSaveF4Error');
    onSaveCompleteFormFourA1();
    setTimeout("onAcceptCompleteFormFour2()", 1500);
}

function onAcceptCompleteFormFour1() {
    //
    dijit.byId('saveFormCompleteDlg').attr('content', "Сохранение Формы-4 успешно завершено.");
    dijit.byId('saveFormCompleteDlg').attr('title', "Сохранение Формы-4");
}

function onAcceptCompleteFormFour2() {
    dijit.byId('saveFormCompleteDlg').hide();
    //document.location.href=getActionUri('services/formfour');
    clearLoadIndicator('loadP', getLoadImg());
}


//
function saveFormFour(tabsCount) {
    var selTab = getSelectedTab(tabsCount);
    if (isValidCurTab(tabsCount, selTab)) {
        var dlg = dijit.byId('saveFormCompleteDlg');
        dlg.show();
        dlg.setContent("");
        postTabAndSaveForm(selTab);
    }
}

function saveFormFourA(tabsCount) {
    var selTab = getSelectedTab(tabsCount);
    if (isValidCurTab(tabsCount, selTab)) {
        var dlg = dijit.byId('saveFormCompleteDlg');
        dlg.show();
        dlg.setContent("");
        postTabAndSaveFormFourA(selTab);
    }
}
function onSaveCompleteFormFour1() {
    //
    dijit.byId('saveFormCompleteDlg').attr('content', "Сохранение Формы-4 успешно завершено.");
    dijit.byId('saveFormCompleteDlg').attr('title', "Сохранение Формы-4");
}
function onSaveCompleteFormFour2() {
    dijit.byId('saveFormCompleteDlg').hide();
    document.location.href = getActionUri('services/formfour');
}
function onSaveCompleteFormFourA1() {
    //
    dijit.byId('saveFormCompleteDlg').attr('content', "Сохранение Формы-4A успешно завершено.");
    dijit.byId('saveFormCompleteDlg').attr('title', "Сохранение Формы-4A");
}
function onSaveCompleteFormFourA2() {
    dijit.byId('saveFormCompleteDlg').hide();
    document.location.href = getActionUri('services/formfour-a');
}


function createFormFourbyOrg(currentOrg) {
    var org = "";
    if (currentOrg) {
        org = "?current_org=" + currentOrg;
    }
    document.location.href = getActionUri("services/formfour-auth-create" + org);
//  document.location.reload();
}

function createFormFourAbyOrg(currentOrg) {
    var org = "";
    if (currentOrg) {
        org = "?current_org=" + currentOrg;
    }
    document.location.href = getActionUri("services/formfour-a-create" + org);
//  document.location.reload();
}

function createFormFourbyPeriodandOrg(orgElm, date) {
    var currentOrg = "";
    var period = "";
    if (orgElm) {
        currentOrg = "?current_org=" + orgElm.getValue();
        if (date) {
            period = "&current_period=" + date;
        }
    } else {
        var period = "";
        if (date) {
            period = "?current_period=" + date;
        }
    }
    document.location.href = getActionUri("services/formfour-auth-create" + currentOrg + period);
//  document.location.reload();
}

function createFormFourAbyPeriodandOrg(orgElm, date) {
    var currentOrg = "";
    var period = "";
    if (orgElm) {
        currentOrg = "?current_org=" + orgElm.getValue();
        if (date) {
            period = "&current_period=" + date;
        }
    } else {
        var period = "";
        if (date) {
            period = "?current_period=" + date;
        }
    }
    document.location.href = getActionUri("services/formfour-a-create" + currentOrg + period);
//  document.location.reload();
}

function createFormFourAbyPeriodandOrg(orgElm, date) {
    var currentOrg = "";
    var period = "";
    if (orgElm) {
        currentOrg = "?current_org=" + orgElm.getValue();
        if (date) {
            period = "&current_period=" + date;
        }
    } else {
        var period = "";
        if (date) {
            period = "?current_period=" + date;
        }
    }
    document.location.href = getActionUri("services/formfour-a-create" + currentOrg + period);
//  document.location.reload();
}

function clearFormFour(auth, tabsCount, type, new_report) {
    var actionPrefix;
    if (auth) {
        if (type == 'F4') {
            actionPrefix = "services/formfour-t";
        } else if (type == 'F4A') {
            actionPrefix = "services/formfour-a-t";
        }
    } else {
        actionPrefix = "f4input-t";
    }
    var tId = getSelectedTab(tabsCount);
    standardServerPost('reportForm', 'contentTable', getActionUri(actionPrefix + '?t=t' + tId + "&ct=t" + tId + "&h=" + Math.random() + "&clear=all&new_report=" + new_report));
}

function loadXML(type) {
    var prefix;
    if (type == 'F4A') {
        prefix = "f4xmlload-a";
    } else {
        prefix = 'f4xmlload';
    }
    var org = dijit.byId("current_org");
    var org_str = "";
    if (org) {
        org_str = "&current_org=" + org.getValue();
    }
    var period = dijit.byId("current_period");
    var period_str = "";
    if (period) {
        period_str = "&current_period=" + period.getValue();
    }
    var rstateElm = document.getElementById("rstate");
    var rstate;
    if (rstateElm) {
        rstate = rstateElm.value;
    }
    document.location.href = getActionUri(prefix + "?type=" + type + org_str + "&rstate=" + encodeURIComponent(rstate) + period_str);
}

function printF4Callback(data, ioArgs) {
    //alert('dldF4InputCallback');
    //if(ioArgs.args.url.indexOf('dldtype=f4input')!=-1){
    standardServerCallback(data, ioArgs);
//document.location.href = "/dld?type=f4input";
//window.open("/dld?type=f4input");
}

function printFormFour(auth, mode, tabsCount) {
    var selTab = getSelectedTab(tabsCount);
    if (isValidCurTab(tabsCount, selTab)) {
        var actionPrefix;
        if (auth) {
            actionPrefix = "services/formfour-t";
        } else {
            actionPrefix = "f4input-t";
        }
        var tId = getSelectedTab(tabsCount);
        var modeStr = "";
        if (mode) {
            modeStr = "&mode=" + mode;
        }
        var rstateElm = document.getElementById("rstate");
        var rstate;
        if (rstateElm) {
            rstate = rstateElm.value;
        }
        servPostSync('reportForm', 'contentTable', getActionUri(actionPrefix + '?t=t' + tId + "&ct=t" + tId + modeStr + "&rstate=" + encodeURIComponent(rstate) + "&h=" + Math.random()), printF4Callback, standardServerError);
        var type;

        rstateElm = document.getElementById("rstate");
        if (rstateElm) {
            rstate = rstateElm.value;
        }
        if (auth) {
            type = "F4" + "&rstate=" + encodeURIComponent(rstate);
        } else {
            type = "F4_INPUT";
        }
        document.location.href = vc_cp + "/f4print?type=" + type;
    }
}
function printFormFourA(auth, mode, tabsCount) {
    var selTab = getSelectedTab(tabsCount);
    if (isValidCurTab(tabsCount, selTab)) {
        var actionPrefix;
        if (auth) {
            actionPrefix = "services/formfour-a-t";
        } else {
            actionPrefix = "f4input-t";
        }
        var tId = getSelectedTab(tabsCount);
        var modeStr = "";
        if (mode) {
            modeStr = "&mode=" + mode;
        }
        var rstateElm = document.getElementById("rstate");
        var rstate;
        if (rstateElm) {
            rstate = rstateElm.value;
        }
        servPostSync('reportForm', 'contentTable', getActionUri(actionPrefix + '?t=t' + tId + "&ct=t" + tId + modeStr + "&rstate=" + encodeURIComponent(rstate) + "&h=" + Math.random()), printF4Callback, standardServerError);
        var type;

        rstateElm = document.getElementById("rstate");
        if (rstateElm) {
            rstate = rstateElm.value;
        }
        if (auth) {
            type = "F4A" + "&rstate=" + encodeURIComponent(rstate);
        } else {
            type = "F4_INPUT";
        }
        document.location.href = vc_cp + "/f4Aprint?type=" + type;
    }
}

function validateFormFour(auth, tabsCount) {
    var selTab = getSelectedTab(tabsCount);
    if (isValidCurTab(tabsCount, selTab)) {
        var actionPrefix;
        if (auth) {
            actionPrefix = "services/formfour-t";
        } else {
            actionPrefix = "f4input-t";
        }
        var tId = getSelectedTab(tabsCount);
        var rstateElm = document.getElementById("rstate");
        var rstate;
        if (rstateElm) {
            rstate = encodeURIComponent(rstateElm.value);
        }
        servPostSync('reportForm', 'contentTable', getActionUri(actionPrefix + '?t=t' + tId + "&ct=t" + tId + "&rstate=" + rstate + "&h=" + Math.random()),
                auth ? validateFormFourAuthCallback : validateFormFourCallback,
                standardServerError);
    }
}
//
function validateLogControlErrors(auth, tabsCount) {
    var selTab = getSelectedTab(tabsCount);
    if (isValidCurTab(tabsCount, selTab)) {
        var actionPrefix;

        //actionPrefix = "services/log-control-errors";

        if (auth) {
            actionPrefix = "services/formfour-t";
        } else {
            actionPrefix = "f4input-t";
        }

        var tId = getSelectedTab(tabsCount);
        var rstateElm = document.getElementById("rstate");
        var rstate;
        if (rstateElm) {
            rstate = encodeURIComponent(rstateElm.value);
        }

        servPostSync('reportForm', 'contentTable', getActionUri(actionPrefix + '?t=t' + tId + "&ct=t" + tId + "&rstate=" + rstate + "&h=" + Math.random()),
                auth ? validateLogControlErrorsAuthCallback : validateLogControlErrorsCallback,
                standardServerError);

    }
}
//
function validateLogControlErrorsAuthCallback() {
    //alert(111)
    var rstateElm = document.getElementById("rstate");
    var rstate;
    if (rstateElm) {
        rstate = encodeURIComponent(rstateElm.value);
    }
    validateLogControlErrorsAjax("services/log-control-errors?type=f4", 'Ошибки логического контроля:');
}
//
function validateLogControlErrorsCallback() {
    //alert(222)
    var rstateElm = document.getElementById("rstate");
    var rstate;
    if (rstateElm) {
        rstate = encodeURIComponent(rstateElm.value);
    }
    validateLogControlErrorsAjax("services/log-control-errors?type=f4_input", 'Ошибки логического контроля:');
}

//
function validateFormFourAuthCallback() {
    //alert('validateFormFourAuthCallback');
    //document.location.href=getActionUri("f4validation?type=f4");
    var rstateElm = document.getElementById("rstate");
    var rstate;
    if (rstateElm) {
        rstate = encodeURIComponent(rstateElm.value);
    }
    validateFormFourAjax("f4validation?type=f4" + "&rstate=" + rstate);
}
function validateFormFourCallback() {
    //alert('validateFormFourCallback');
    //document.location.href=getActionUri("f4validation?type=f4input");
    validateFormFourAjax("f4validation?type=f4_input");
}
//
function validateFormFourAjax(url) {
    var uri = getActionUri(url);
    dojo.xhrPost({
        url: uri,
        handleAs: 'text',
        load: function(data) {
            validateFormFourDialog(data);
        },
        error: function() {
        }
    });
}
//
function validateLogControlErrorsAjax(url, title) {
    var uri = getActionUri(url);
    dojo.xhrPost({
        url: uri,
        handleAs: 'text',
        load: function(data) {
            validateFormFourDialog(data, title);
        },
        error: function() {
        }
    });
}

function validateFormFourDialog(data, aTitle) {
    if (!aTitle)
        var aTitle = "Результат проверки:";
    var newContent = "<div style='border:1px solid #ccc;width:710px;*width:720px;height:445px;overflow-y:scroll;position:relative;top:2px !important;padding:4px;'>" + data + "</div><div style='text-align:center;padding:10px;*padding:5px;'><input label='Закрыть' dojoType='dijit.form.Button' type='button' onclick='dijit.byId(\"validationResult\").hide();'/></div>";
    try {
        if (dijit.byId("validationResult")) {
            dijit.byId("validationResult").set("title", aTitle);
            dijit.byId("validationResult").set("content", newContent);
            dijit.byId("validationResult").show();
        } else {
            var mess = "<div>" + data + "</div>";
            new dijit.Dialog({
                id: "validationResult",
                title: aTitle,
                style: "width:740px !important;height:532px !important;*height:524px !important;",
                content: newContent
            }, "").show();
        }
    } catch (e) {
        //alert("Exception: "+e);
    }

}

function goToF4Input() {
    document.location.href = getActionUri("f4input");
}
function goToF4() {
    history.back();
}

function viewForm(cId) {
    document.location.href = getActionUri("services/formfour-view?cid=" + cId);
}

function viewFormFourA(cId) {
    document.location.href = getActionUri("services/formfour-a-view?cid=" + cId);
}
function viewCacheForm(cId) {
    document.location.href = getActionUri("services/formfour-pass-view?cid=" + cId);
}
function editForm(cId) {
    // stub!!!
    //viewForm(cId);
    document.location.href = getActionUri("services/formfour-edit?cid=" + cId);
}
function editFormFourA(cId) {
    // stub!!!
    //viewForm(cId);
    document.location.href = getActionUri("services/formfour-a-edit?cid=" + cId);
}
function removeForm(cId, tit) {
    //alert('removeForm(fId)');
    if (confirm("Вы действительно желаете удалить отчет за данный период: " + tit + "?")) {
        document.location.href = getActionUri("services/formfour-remove?cid=" + cId);
    }
}
function removeFormFourA(cId, tit) {
    //alert('removeForm(fId)');
    if (confirm("Вы действительно желаете удалить отчет за данный период: " + tit + "?")) {
        document.location.href = getActionUri("services/formfour-a-remove?cid=" + cId);
    }
}
function cF(tId, cFId, v) {
    //alert('calcF');
    if (tId != 't1r11' && tId != 't1r14' && tId != 't1r17' && tId != 't1r1' && tId != 't1r4' && tId != 't1r7') {
        var c1 = dijit.byId(tId + '_1');
        var c2 = dijit.byId(tId + '_2');
        var c3 = dijit.byId(tId + '_3');
        var res = 0;
        var r1 = c1.getValue();
        var r2 = c2.getValue();
        var r3 = c3.getValue();
        if (!isNaN(r1))
            res += r1;
        if (!isNaN(r2))
            res += r2;
        if (!isNaN(r3))
            res += r3;
        dijit.byId(tId + '-sum').setValue(res);
        dijit.byId(tId + '-total').setValue(res);
    }
    if (tId == 't1r11') {
        dijit.byId('t1r9').setValue(dijit.byId('t1r11').getValue());
    }
    if (tId == 't1r14') {
        dijit.byId('t1r12').setValue(dijit.byId('t1r14').getValue());
    }
    if (tId == 't1r15' || tId == 't1r16' || tId == 't1r17' || tId == 't1r11' || tId == 't1r14') {
        var rr = 0;
        var v = dijit.byId('t1r15-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t1r16-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t1r17').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t1r9').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t1r12').getValue();
        rr = addVal(rr, v);
        dijit.byId('t1r18').setValue(rr);
    }
    if (tId == 't1r1' || tId == 't1r2' || tId == 't1r3' || tId == 't1r4' || tId == 't1r5' || tId == 't1r6' || tId == 't1r7') {//alert('fsum');
        var rr = 0;
        var v = dijit.byId('t1r1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t1r2-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t1r3-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t1r5-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t1r6-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t1r4').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t1r7').getValue();
        rr = addVal(rr, v);
        dijit.byId('t1r8').setValue(rr);
    }
}
function calc(tId, crNumber) {
    if (tId == 't2') {
        var rr = 0;
        var v = dijit.byId('t2r2_1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r2_2').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r2_3').getValue();
        rr = addVal(rr, v);
        var elm = dijit.byId('t2r2-sum');
        if (elm) {
            elm.setValue(rr);
        }
        v = dijit.byId('t2r2-begin').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r2-total');
        if (elm) {
            elm.setValue(rr);
        }
        rr = 0;
        v = dijit.byId('t2r3_1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r3_2').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r3_3').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r3-sum');
        if (elm) {
            elm.setValue(rr);
        }
        v = dijit.byId('t2r3-begin').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r3-total');
        if (elm) {
            elm.setValue(rr);
        }
        rr = 0;
        v = dijit.byId('t2r5_1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r5_2').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r5_3').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r5-sum');
        if (elm) {
            elm.setValue(rr);
        }
        v = dijit.byId('t2r5-begin').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r5-total');
        if (elm) {
            elm.setValue(rr);
        }
        rr = 0;
        v = dijit.byId('t2r6_1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r6_2').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r6_3').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r6-sum');
        if (elm) {
            elm.setValue(rr);
        }
        v = dijit.byId('t2r6-begin').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r6-total');
        if (elm) {
            elm.setValue(rr);
        }
        rr = 0;
        v = dijit.byId('t2r15_1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r15_2').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r15_3').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r15-sum');
        if (elm) {
            elm.setValue(rr);
        }
        v = dijit.byId('t2r15-begin').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r15-total');
        if (elm) {
            elm.setValue(rr);
        }
        rr = 0;
        v = dijit.byId('t2r16_1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r16_2').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r16_3').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r16-sum');
        if (elm) {
            elm.setValue(rr);
        }
        v = dijit.byId('t2r16-begin').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r16-total');
        if (elm) {
            elm.setValue(rr);
        }
        rr = 0;
        v = dijit.byId('t2r1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r2-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r3-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r4').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r5-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r6-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r7').getValue();
        rr = addVal(rr, v);
        dijit.byId('t2r8').setValue(rr);
        rr = 0;
        v = dijit.byId('t2r12').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r15-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r16-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r17').getValue();
        rr = addVal(rr, v);
        dijit.byId('t2r18').setValue(rr);

        rr = 0;
        var elm = dijit.byId('t2r12');
        if (elm && !isNaN(elm.getValue()))
            rr += elm.getValue();
        var elm = dijit.byId('t2r14');
        if (elm && !isNaN(elm.getValue()))
            rr -= elm.getValue();
        var elm = dijit.byId('t2r13');
        if (elm) {
            elm.setValue(rr);
        }

        var d = 0;
        v = dijit.byId('t2r18').getValue();
        d = addVal(d, v);
        elm = dijit.byId('t2r8');
        if (elm && !isNaN(elm.getValue()))
            d -= elm.getValue();
        var dIns = (d < 0) ? -d : 0;
        elm = dijit.byId('t2r19');
        if (elm) {
            elm.setValue(roundValue(dIns));
        }
        var dFss = (d < 0) ? 0 : d;
        elm = dijit.byId('t2r9');
        if (elm) {
            elm.setValue(roundValue(dFss));
        }
        rr = dFss;
        elm = dijit.byId('t2r11');
        if (elm && !isNaN(elm.getValue())) {
            rr -= elm.getValue();
        }
        var elm = dijit.byId('t2r10');
        if (elm) {
            elm.setValue(roundValue(rr));
        }
    }
    if (tId == 't3') {
        var rr = 0;
        rr = addElmValue(rr, 't3r8c' + crNumber);
        rr = addElmValue(rr, 't3r9c' + crNumber);
        dijit.byId('t3r7c' + crNumber).setValue(rr);
        if (crNumber != '2') {
            rr = 0;
            rr = addElmValue(rr, 't3r1c' + crNumber);
            rr = addElmValue(rr, 't3r3c' + crNumber);
            rr = addElmValue(rr, 't3r5c' + crNumber);
            rr = addElmValue(rr, 't3r6c' + crNumber);
            rr = addElmValue(rr, 't3r7c' + crNumber);
            rr = addElmValue(rr, 't3r10c' + crNumber);
            rr = addElmValue(rr, 't3r11c' + crNumber);
            dijit.byId('t3r12c' + crNumber).setValue(rr);
        }
    }
    if (tId == 't4') {
        var rr = 0;
        var elm = dijit.byId('t4r1c' + crNumber);
        if (elm && !isNaN(elm.getValue()))
            rr += elm.getValue();
        elm = dijit.byId('t4r2c' + crNumber);
        if (elm && !isNaN(elm.getValue()))
            rr -= elm.getValue();
        elm = dijit.byId('t4r3c' + crNumber);
        if (elm && !isNaN(elm.getValue()))
            rr -= elm.getValue();
        dijit.byId('t4r4c' + crNumber).setValue(rr);
    }
    if (tId == 't5') {
        var table_to_change = document.getElementById("table_to_change");
        var sum = 0;
        for (var i = 0; i < table_to_change.rows.length; i++) {
            if (table_to_change.rows[i].id.indexOf("row" == 0)) {
                var rowId = table_to_change.rows[i].id.substr(3);
                if (dijit.byId('t5r' + rowId + 'c' + crNumber) && !isNaN(dijit.byId('t5r' + rowId + 'c' + crNumber).value)) {
                    sum += dijit.byId('t5r' + rowId + 'c' + crNumber).value;
                }
            }
        }
        dijit.byId('t5sum' + crNumber).setValue(sum);
    }
    if (tId == 't6') {
        if (dijit.byId('t6r1c' + crNumber).value != '' && dijit.byId('t6r1c' + crNumber).value != '0') {
            dijit.byId('t6r3c' + crNumber).setValue(dijit.byId('t6r2c' + crNumber).value * 100 / dijit.byId('t6r1c' + crNumber).value);
        }
        if (dijit.byId('t6r4c' + crNumber).value != '' && dijit.byId('t6r4c' + crNumber).value != '0') {
            dijit.byId('t6r6c' + crNumber).setValue(dijit.byId('t6r5c' + crNumber).value * 100 / dijit.byId('t6r4c' + crNumber).value);
        }
        if (dijit.byId('t6r7c' + crNumber).value != '' && dijit.byId('t6r7c' + crNumber).value != '0') {
            dijit.byId('t6r9c' + crNumber).setValue(dijit.byId('t6r8c' + crNumber).value * 100 / dijit.byId('t6r7c' + crNumber).value);
        }
    }
    if (tId == 't7') {
        if (dijit.byId('t7r2c' + crNumber).value != '' && dijit.byId('t7r2c' + crNumber).value != '0') {
            dijit.byId('t7r4c' + crNumber).setValue(dijit.byId('t7r3c' + crNumber).value * 100 / dijit.byId('t7r2c' + crNumber).value);
        }
    }
    if (tId == 't8') {
        var rr = 0;
        if (crNumber != '6' && crNumber != '9' && crNumber != '15') {
            var elm = dijit.byId('t8r4c' + crNumber);
            if (elm && !isNaN(elm.getValue()))
                rr += elm.getValue();
            var elm = dijit.byId('t8r5c' + crNumber);
            if (elm && !isNaN(elm.getValue()))
                rr += elm.getValue();
            if (dijit.byId('t8r3c' + crNumber))
                dijit.byId('t8r3c' + crNumber).setValue(rr);
        }
        rr = 0;
        var elm = dijit.byId('t8r1c' + crNumber);
        if (elm && !isNaN(elm.getValue()))
            rr += elm.getValue();
        elm = dijit.byId('t8r2c' + crNumber);
        if (elm && !isNaN(elm.getValue()))
            rr += elm.getValue();
        elm = dijit.byId('t8r3c' + crNumber);
        if (elm && !isNaN(elm.getValue()))
            rr += elm.getValue();
        elm = dijit.byId('t8r6c' + crNumber);
        if (elm && !isNaN(elm.getValue()))
            rr += elm.getValue();
        if (dijit.byId('t8r7c' + crNumber))
            dijit.byId('t8r7c' + crNumber).setValue(rr);
        var sums = [0, 0, 0];
        for (var i = 1; i <= 6; i++) {
            for (var j = 0; j <= 2; j++) {
                rr = 0;
                for (var k = 0; k <= 4; k++) {
                    var elm = dijit.byId('t8r' + i + 'c' + (6 + k * 3 + j));
                    if (elm && !isNaN(elm.getValue()))
                        rr += elm.getValue();
                }
                dijit.byId('t8r' + i + 'c' + (j + 3)).setValue(rr);
                if (i != 4 && i != 5) {
                    sums[j] += rr;
                }
            }
        }
        if (dijit.byId('t8r7c3') && sums[0] != 0)
            dijit.byId('t8r7c3').setValue(sums[0]);
        if (dijit.byId('t8r7c5') && sums[2] != 0)
            dijit.byId('t8r7c5').setValue(sums[2]);
    }
    /*if (tId=='t9') {
     if (crNumber) {
     dijit.byId('t9r2c'+crNumber).setValue(dijit.byId('t9r3c'+crNumber).value + dijit.byId('t9r4c'+crNumber).value + dijit.byId('t9r5c'+crNumber).value);
     } else {
     dijit.byId('t9r1c8').setValue(dijit.byId('t9r1c4').value*(1-dijit.byId('t9r1c5').value/100+dijit.byId('t9r1c7').value/100));
     }
     } */
    if (tId == 't10_1') {
        if (crNumber == '3' || crNumber == '4' || crNumber == '5') {
            var rr = 0;
            rr = addElmValue(rr, 't10_1r3c' + crNumber);
            rr = addElmValue(rr, 't10_1r4c' + crNumber);
            rr = addElmValue(rr, 't10_1r5c' + crNumber);
            if (dijit.byId('t10_1r2c' + crNumber))
                dijit.byId('t10_1r2c' + crNumber).setValue(rr);
        } else {
            var v1 = isNaN(dijit.byId('t10_1r5c7').value) ? 0 : dijit.byId('t10_1r5c7').getValue();
            var v2 = isNaN(dijit.byId('t10_1r5c9').value) ? 0 : dijit.byId('t10_1r5c9').getValue();
            if (!isNaN(dijit.byId('t10_1r5c6').value)) {
                dijit.byId('t10_1r5c10').setValue(dijit.byId('t10_1r5c6').getValue() * (1 - v1 / 100 + v2 / 100));
            } else {
                dijit.byId('t10_1r5c10').setValue(0);
            }
        }
    }
    if (tId == 't10_2') {
        var rr = 0;
        rr = addElmValue(rr, 't10_2r2_1');
        rr = addElmValue(rr, 't10_2r2_2');
        rr = addElmValue(rr, 't10_2r2_3');
        if (dijit.byId('t10_2r2-sum'))
            dijit.byId('t10_2r2-sum').setValue(rr);
        rr = addElmValue(rr, 't10_2r2-begin');
        if (dijit.byId('t10_2r2-total'))
            dijit.byId('t10_2r2-total').setValue(rr);
        rr = 0;
        rr = addElmValue(rr, 't10_2r1');
        rr = addElmValue(rr, 't10_2r2-total');
        rr = addElmValue(rr, 't10_2r3');
        rr = addElmValue(rr, 't10_2r4');
        rr = addElmValue(rr, 't10_2r5');
        rr = addElmValue(rr, 't10_2r6');
        rr = addElmValue(rr, 't10_2r7');
        if (dijit.byId('t10_2r8'))
            dijit.byId('t10_2r8').setValue(rr);
        rr = 0;
        rr = addElmValue(rr, 't10_2r11_1');
        rr = addElmValue(rr, 't10_2r11_2');
        rr = addElmValue(rr, 't10_2r11_3');
        if (dijit.byId('t10_2r11-sum'))
            dijit.byId('t10_2r11-sum').setValue(rr);
        rr = addElmValue(rr, 't10_2r11-begin');
        if (dijit.byId('t10_2r11-total'))
            dijit.byId('t10_2r11-total').setValue(rr);
        rr = 0;
        rr = addElmValue(rr, 't10_2r12_1');
        rr = addElmValue(rr, 't10_2r12_2');
        rr = addElmValue(rr, 't10_2r12_3');
        if (dijit.byId('t10_2r12-sum'))
            dijit.byId('t10_2r12-sum').setValue(rr);
        rr = addElmValue(rr, 't10_2r12-begin');
        if (dijit.byId('t10_2r12-total'))
            dijit.byId('t10_2r12-total').setValue(rr);
        rr = 0;
        rr = addElmValue(rr, 't10_2r10');
        rr = addElmValue(rr, 't10_2r11-total');
        rr = addElmValue(rr, 't10_2r12-total');
        rr = addElmValue(rr, 't10_2r13');
        if (dijit.byId('t10_2r14'))
            dijit.byId('t10_2r14').setValue(rr);

        var d = 0;
        v = dijit.byId('t10_2r14').getValue();
        d = addVal(d, v);
        elm = dijit.byId('t10_2r8');
        if (elm && !isNaN(elm.getValue()))
            d -= elm.getValue();
        var dIns = (d < 0) ? -d : 0;
        elm = dijit.byId('t10_2r15');
        if (elm) {
            elm.setValue(roundValue(dIns));
        }
        var dFss = (d < 0) ? 0 : d;
        elm = dijit.byId('t10_2r9');
        if (elm) {
            elm.setValue(roundValue(dFss));
        }
    }
    if (tId == 't11_1') {
        var rr = 0;
        rr = addElmValue(rr, 't11_1r1c2');
        rr = addElmValue(rr, 't11_1r4c2');
        rr = addElmValue(rr, 't11_1r7c2');
        rr = addElmValue(rr, 't11_1r9c2');
        if (dijit.byId('t11_1r10c2'))
            dijit.byId('t11_1r10c2').setValue(rr);
    }
    if (tId == 't11_2') {
        var rr = 0;
        rr = addElmValue(rr, 't11_2r1');
        rr = addElmValue(rr, 't11_2r3');
        if (dijit.byId('t11_2r4'))
            dijit.byId('t11_2r4').setValue(rr);
    }
}

function roundValue(value) {
    if (value) {
        var value1 = value.toFixed(2);
        return value1.replace(".", ",");
    }
    return 0;
}

function accumulate(accumulator, elems) {
    for (var i=0; i < elems.length; i++) {
        accumulator = addElmValue(accumulator, elems[i]);
    }
    return accumulator;
}

function calc2015t3c3() {
    var t3r9c3 = accumulate(0, ['t3r10c3', 't3r11c3']);
    dijit.byId('t3r9c3').setValue(t3r9c3);
}

function calc2015t3c4() {
    var t3r9c4 = accumulate(0, ['t3r10c4', 't3r11c4']);
    dijit.byId('t3r9c4').setValue(t3r9c4);

    var t3r15c4 = accumulate(t3r9c4, ['t3r1c4', 'S3R9C2', 't3r5c4', 't3r7c4', 't3r8c4', 't3r12c4', 'S3R11C2', 'S3R8C2']);

    dijit.byId('t3r15c4').setValue(t3r15c4);
}

function calc2015t3c5() {
    var t3r9c5 = accumulate(0, ['t3r10c5', 't3r11c5']);
    dijit.byId('t3r9c5').setValue(t3r9c5);

    var t3r15c5 = accumulate(t3r9c5, ['t3r1c5', 't3r5c5', 't3r12c5', 'S3R11C3', 'S3R8C3']);
    dijit.byId('t3r15c5').setValue( t3r15c5);
}

function calc2016t3c5() {
    var t3r9c5 = accumulate(0, ['t3r10c5', 't3r11c5']);
    dijit.byId('t3r9c5').setValue(t3r9c5);

    var t3r15c5 = accumulate(t3r9c5, ['t3r1c5', 't3r5c5', 't3r12c5', 'S3R11C3']);
    dijit.byId('t3r15c5').setValue( t3r15c5);
}

function calc2015(tId, crNumber) {
    console.log("calc2015", tId, crNumber);
    if (tId == 't2') {
        var rr = 0;
        var v = dijit.byId('t2r2_1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r2_2').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r2_3').getValue();
        rr = addVal(rr, v);
        var elm = dijit.byId('t2r2-sum');
        if (elm) {
            elm.setValue(rr);
        }
        v = dijit.byId('t2r2-begin').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r2-total');
        if (elm) {
            elm.setValue(rr);
        }
        rr = 0;
        v = dijit.byId('t2r3_1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r3_2').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r3_3').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r3-sum');
        if (elm) {
            elm.setValue(rr);
        }
        v = dijit.byId('t2r3-begin').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r3-total');
        if (elm) {
            elm.setValue(rr);
        }
        rr = 0;
        v = dijit.byId('t2r5_1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r5_2').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r5_3').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r5-sum');
        if (elm) {
            elm.setValue(rr);
        }
        v = dijit.byId('t2r5-begin').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r5-total');
        if (elm) {
            elm.setValue(rr);
        }
        rr = 0;
        v = dijit.byId('t2r6_1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r6_2').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r6_3').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r6-sum');
        if (elm) {
            elm.setValue(rr);
        }
        v = dijit.byId('t2r6-begin').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r6-total');
        if (elm) {
            elm.setValue(rr);
        }
        rr = 0;
        v = dijit.byId('t2r15_1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r15_2').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r15_3').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r15-sum');
        if (elm) {
            elm.setValue(rr);
        }
        v = dijit.byId('t2r15-begin').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r15-total');
        if (elm) {
            elm.setValue(rr);
        }
        rr = 0;
        v = dijit.byId('t2r16_1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r16_2').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r16_3').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r16-sum');
        if (elm) {
            elm.setValue(rr);
        }
        v = dijit.byId('t2r16-begin').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r16-total');
        if (elm) {
            elm.setValue(rr);
        }
        rr = 0;
        v = dijit.byId('t2r1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r2-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r3-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r4').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r5-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r6-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r7').getValue();
        rr = addVal(rr, v);
        dijit.byId('t2r8').setValue(rr);
        rr = 0;
        v = dijit.byId('t2r12').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r15-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r16-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r17').getValue();
        rr = addVal(rr, v);
        dijit.byId('t2r18').setValue(rr);

        rr = 0;
        var elm = dijit.byId('t2r12');
        if (elm && !isNaN(elm.getValue()))
            rr += elm.getValue();
        var elm = dijit.byId('t2r14');
        if (elm && !isNaN(elm.getValue()))
            rr -= elm.getValue();
        var elm = dijit.byId('t2r13');
        if (elm) {
            elm.setValue(rr);
        }

        var d = 0;
        v = dijit.byId('t2r18').getValue();
        d = addVal(d, v);
        elm = dijit.byId('t2r8');
        if (elm && !isNaN(elm.getValue()))
            d -= elm.getValue();
        var dIns = (d < 0) ? -d : 0;
        elm = dijit.byId('t2r19');
        if (elm) {
            elm.setValue(roundValue(dIns));
        }
        var dFss = (d < 0) ? 0 : d;
        elm = dijit.byId('t2r9');
        if (elm) {
            elm.setValue(roundValue(dFss));
        }
        rr = dFss;
        elm = dijit.byId('t2r11');
        if (elm && !isNaN(elm.getValue())) {
            rr -= elm.getValue();
        }
        var elm = dijit.byId('t2r10');
        if (elm) {
            elm.setValue(roundValue(rr));
        }
    }

    if (tId == 't3') {
        calc2015t3c3();
        calc2015t3c4();
        calc2015t3c5();
    }

    if (tId == 't4') {
        var rr = 0;
        var elm = dijit.byId('t4r1c' + crNumber);
        if (elm && !isNaN(elm.getValue()))
            rr += elm.getValue();
        elm = dijit.byId('t4r2c' + crNumber);
        if (elm && !isNaN(elm.getValue()))
            rr -= elm.getValue();
        elm = dijit.byId('t4r3c' + crNumber);
        if (elm && !isNaN(elm.getValue()))
            rr -= elm.getValue();
        dijit.byId('t4r4c' + crNumber).setValue(rr);
    }

    if (tId == 't7_1') {
        var rr=0;
        var row3 = dijit.byId('t7_1r3c' + crNumber);
        var row2 = dijit.byId('t7_1r2c' + crNumber);
        if((row3 && !isNaN(row3.getValue())) && (row2 && !isNaN(row2.getValue()) && row2 != 0)){
            rr = (row3 / row2) * 100;
            dijit.byId('t7_1r4c' + crNumber).setValue(rr);
        }
    }
//    t7_2r3
    if (tId == 't7_2') {
        var res=0;
        var row2 = dijit.byId('t7_2r2' + crNumber);
        var row1 = dijit.byId('t7_2r1' + crNumber);
        if((row2 && !isNaN(row2.getValue())) && (row1 && !isNaN(row1.getValue()) && row1 != 0)){
            res = (row2 / row1) * 100;
            dijit.byId('t7_2r3' + crNumber).setValue(res);
        }
    }
    if (tId == 't7_3') {
        var res = 0;
        var sum = 0;
        var row1 = dijit.byId('t7_3r1c' + crNumber);
        sum = addElmValue(sum, "t7_3r2c" + crNumber);
        sum = addElmValue(sum, "t7_3r3c" + crNumber);
        sum = addElmValue(sum, "t7_3r4c" + crNumber);
        if(row1 && !isNaN(row1.getValue()) && row1 != 0) {
            res = (sum / row1) * 100;
            dijit.byId('t7_3r5c' + crNumber).setValue(res);
        }
    }
    if (tId == 't8') {
        var res = 0;
        if (crNumber != '6' && crNumber != '9' && crNumber != '15') {
            var elm = dijit.byId('t8r4c' + crNumber);
            if (elm && !isNaN(elm.getValue()))
                res += elm.getValue();
            var elm = dijit.byId('t8r5c' + crNumber);
            if (elm && !isNaN(elm.getValue()))
                res += elm.getValue();
            if (dijit.byId('t8r3c' + crNumber))
                dijit.byId('t8r3c' + crNumber).setValue(res);
        }
//        res = 0;
//        var elm = dijit.byId('t8r1c' + crNumber);
//        if (elm && !isNaN(elm.getValue()))
//            res += elm.getValue();
//        elm = dijit.byId('t8r2c' + crNumber);
//        if (elm && !isNaN(elm.getValue()))
//            res += elm.getValue();
//        elm = dijit.byId('t8r3c' + crNumber);
//        if (elm && !isNaN(elm.getValue()))
//            res += elm.getValue();
//        elm = dijit.byId('t8r6c' + crNumber);
//        if (elm && !isNaN(elm.getValue()))
//            res += elm.getValue();
//        if (dijit.byId('t8r7c' + crNumber))
//            dijit.byId('t8r7c' + crNumber).setValue(res);
        var sums = [0, 0, 0];
        for (var i = 1; i <= 6; i++) {
            for (var j = 0; j <= 2; j++) {
                res = 0;
                for (var k = 0; k <= 4; k++) {
                    var elm = dijit.byId('t8r' + i + 'c' + (6 + k * 3 + j));
                    if (elm && !isNaN(elm.getValue()))
                        res += elm.getValue();
                }
                dijit.byId('t8r' + i + 'c' + (j + 3)).setValue(res);
                if (i != 4 && i != 5) {
                    sums[j] += res;
                }
            }
        }

        var idx = [1, 2, 3, 6, 7];
        res = 0;
        for (var i=0; i < idx.length; i++) {
            res = addElmValue(res, dijit.byId("t8r"+ idx[i] +"c3"));
        }
        dijit.byId("t8r9c3").setValue(res)

        idx = [1, 2, 3, 6, 7, 8];
        res = 0;
        for (var i=0; i < idx.length; i++) {
            res = addElmValue(res, dijit.byId("t8r"+ idx[i] +"c5"));
        }
        dijit.byId("t8r9c5").setValue(res)

        idx = [1, 2, 3, 6];
        res = 0;
        for (var i=0; i < idx.length; i++) {
            res = addElmValue(res, dijit.byId("t8r" + idx[i] + "c6"));
        }
        dijit.byId("t8r9c6").setValue(res)

        idx = [1, 2, 3, 6];
        res = 0;
        for (var i=0; i < idx.length; i++) {
            res = addElmValue(res, dijit.byId("t8r"+ idx[i] +"c8"));
        }
        dijit.byId("t8r9c8").setValue(res)

        idx = [1, 2, 3, 6];
        res = 0;
        for (var i=0; i < idx.length; i++) {
            res = addElmValue(res, dijit.byId("t8r"+ idx[i] +"c9"));
        }
        dijit.byId("t8r9c9").setValue(res)

        idx = [1, 2, 3, 6];
        res = 0;
        for (var i=0; i < idx.length; i++) {
            res = addElmValue(res, dijit.byId("t8r"+ idx[i] +"c11"));
        }
        dijit.byId("t8r9c11").setValue(res)

        res = addElmValue(0, dijit.byId("t8r1c12"));

        dijit.byId("t8r9c12").setValue(res)

        res = addElmValue(0, dijit.byId("t8r1c14"));

        dijit.byId("t8r9c14").setValue(res)

        idx = [1, 2, 3, 6];
        res = 0;
        for (var i=0; i < idx.length; i++) {
            res = addElmValue(res, dijit.byId("t8r"+ idx[i] +"c15"));
        }
        dijit.byId("t8r9c15").setValue(res)

        idx = [1, 2, 3, 6];
        res = 0;
        for (var i=0; i < idx.length; i++) {
            res = addElmValue(res, dijit.byId("t8r"+ idx[i] +"c17"));
        }
        dijit.byId("t8r9c17").setValue(res)

        idx = [1, 2];
        res = 0;
        for (var i=0; i < idx.length; i++) {
            res = addElmValue(res, dijit.byId("t8r"+ idx[i] +"c18"));
        }
        dijit.byId("t8r9c18").setValue(res)

        idx = [1, 2];
        res = 0;
        for (var i=0; i < idx.length; i++) {
            res = addElmValue(res, dijit.byId("t8r"+ idx[i] +"c20"));
        }
        dijit.byId("t8r9c20").setValue(res)
    }

    if (tId == 't10_1') {
        if (crNumber == '3' || crNumber == '4' || crNumber == '5') {
            var rr = 0;
            rr = addElmValue(rr, 't10_1r3c' + crNumber);
            rr = addElmValue(rr, 't10_1r4c' + crNumber);
            rr = addElmValue(rr, 't10_1r5c' + crNumber);
            if (dijit.byId('t10_1r2c' + crNumber))
                dijit.byId('t10_1r2c' + crNumber).setValue(rr);
        } else {
            var v1 = isNaN(dijit.byId('t10_1r5c7').value) ? 0 : dijit.byId('t10_1r5c7').getValue();
            var v2 = isNaN(dijit.byId('t10_1r5c9').value) ? 0 : dijit.byId('t10_1r5c9').getValue();
            if (!isNaN(dijit.byId('t10_1r5c6').value)) {
                dijit.byId('t10_1r5c10').setValue(dijit.byId('t10_1r5c6').getValue() * (1 - v1 / 100 + v2 / 100));
            } else {
                dijit.byId('t10_1r5c10').setValue(0);
            }
        }
    }

    if (tId == 't10_2') {
        var rr = 0;
        rr = addElmValue(rr, 't10_2r2_1');
        rr = addElmValue(rr, 't10_2r2_2');
        rr = addElmValue(rr, 't10_2r2_3');
        if (dijit.byId('t10_2r2-sum'))
            dijit.byId('t10_2r2-sum').setValue(rr);
        rr = addElmValue(rr, 't10_2r2-begin');
        if (dijit.byId('t10_2r2-total'))
            dijit.byId('t10_2r2-total').setValue(rr);
        rr = 0;
        rr = addElmValue(rr, 't10_2r1');
        rr = addElmValue(rr, 't10_2r2-total');
        rr = addElmValue(rr, 't10_2r3');
        rr = addElmValue(rr, 't10_2r4');
        rr = addElmValue(rr, 't10_2r5');
        rr = addElmValue(rr, 't10_2r6');
        rr = addElmValue(rr, 't10_2r7');
        if (dijit.byId('t10_2r8'))
            dijit.byId('t10_2r8').setValue(rr);
        rr = 0;
        rr = addElmValue(rr, 't10_2r11_1');
        rr = addElmValue(rr, 't10_2r11_2');
        rr = addElmValue(rr, 't10_2r11_3');
        if (dijit.byId('t10_2r11-sum'))
            dijit.byId('t10_2r11-sum').setValue(rr);
        rr = addElmValue(rr, 't10_2r11-begin');
        if (dijit.byId('t10_2r11-total'))
            dijit.byId('t10_2r11-total').setValue(rr);
        rr = 0;
        rr = addElmValue(rr, 't10_2r12_1');
        rr = addElmValue(rr, 't10_2r12_2');
        rr = addElmValue(rr, 't10_2r12_3');
        if (dijit.byId('t10_2r12-sum'))
            dijit.byId('t10_2r12-sum').setValue(rr);
        rr = addElmValue(rr, 't10_2r12-begin');
        if (dijit.byId('t10_2r12-total'))
            dijit.byId('t10_2r12-total').setValue(rr);
        rr = 0;
        rr = addElmValue(rr, 't10_2r10');
        rr = addElmValue(rr, 't10_2r11-total');
        rr = addElmValue(rr, 't10_2r12-total');
        rr = addElmValue(rr, 't10_2r13');
        if (dijit.byId('t10_2r14'))
            dijit.byId('t10_2r14').setValue(rr);

        var d = 0;
        v = dijit.byId('t10_2r14').getValue();
        d = addVal(d, v);
        elm = dijit.byId('t10_2r8');
        if (elm && !isNaN(elm.getValue()))
            d -= elm.getValue();
        var dIns = (d < 0) ? -d : 0;
        elm = dijit.byId('t10_2r15');
        if (elm) {
            elm.setValue(roundValue(dIns));
        }
        rr = 0;
        var row1 = dijit.byId('t10_2r9').getValue();
        var row3 = dijit.byId('t10_2r9_2').getValue();
        elm = dijit.byId('T7P10');
        if (elm && !isNaN(row1) && !isNaN(row3)) {
            rr = row1 - row3;
            rr = (rr < 0) ? 0 : rr;
            elm.setValue(roundValue(rr));
        }
        rr = 0;
        row1 = dijit.byId('t10_2r10').getValue();
        row3 = dijit.byId('t10_2r10_2').getValue();
        elm = dijit.byId('t10_2r10_1');
        if (elm && !isNaN(row1) && !isNaN(row3)) {
            rr = row1 - row3;
            rr = (rr < 0) ? 0 : rr;
            elm.setValue(roundValue(rr));
        }
    }

    if(tId=="t11_1") {
        var res = addElmValue(0, "t11_1r1c2");
        res = addElmValue(res, "t11_1r4c2");
        res = addElmValue(res, "t11_1r7c2");
        res = addElmValue(res, "t11_1r9c2");
        elm = dijit.byId('t11_1r10c2');
        if (elm) {
            elm.setValue(res);
        }
    }

    if(tId == "t11_2"){
        var res = addElmValue(0, "t11_2r1");
        //res = addElmValue(res, "t11_2r2");
        res = addElmValue(res, "t11_2r3");
        elm = dijit.byId('t11_2r4');
        if (elm) {
            elm.setValue(res);
        }
    }

}

function calc2016(tId, crNumber) {
    console.log("calc2016", tId, crNumber);
    if (tId == 't2') {
        var rr = 0;
        var v = dijit.byId('t2r2_1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r2_2').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r2_3').getValue();
        rr = addVal(rr, v);
        var elm = dijit.byId('t2r2-sum');
        if (elm) {
            elm.setValue(rr);
        }
        v = dijit.byId('t2r2-begin').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r2-total');
        if (elm) {
            elm.setValue(rr);
        }
        rr = 0;
        v = dijit.byId('t2r3_1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r3_2').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r3_3').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r3-sum');
        if (elm) {
            elm.setValue(rr);
        }
        v = dijit.byId('t2r3-begin').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r3-total');
        if (elm) {
            elm.setValue(rr);
        }
        rr = 0;
        v = dijit.byId('t2r5_1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r5_2').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r5_3').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r5-sum');
        if (elm) {
            elm.setValue(rr);
        }
        v = dijit.byId('t2r5-begin').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r5-total');
        if (elm) {
            elm.setValue(rr);
        }
        rr = 0;
        v = dijit.byId('t2r6_1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r6_2').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r6_3').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r6-sum');
        if (elm) {
            elm.setValue(rr);
        }
        v = dijit.byId('t2r6-begin').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r6-total');
        if (elm) {
            elm.setValue(rr);
        }
        rr = 0;
        v = dijit.byId('t2r15_1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r15_2').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r15_3').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r15-sum');
        if (elm) {
            elm.setValue(rr);
        }
        v = dijit.byId('t2r15-begin').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r15-total');
        if (elm) {
            elm.setValue(rr);
        }
        rr = 0;
        v = dijit.byId('t2r16_1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r16_2').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r16_3').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r16-sum');
        if (elm) {
            elm.setValue(rr);
        }
        v = dijit.byId('t2r16-begin').getValue();
        rr = addVal(rr, v);
        elm = dijit.byId('t2r16-total');
        if (elm) {
            elm.setValue(rr);
        }
        rr = 0;
        v = dijit.byId('t2r1').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r2-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r3-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r4').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r5-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r6-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r7').getValue();
        rr = addVal(rr, v);
        dijit.byId('t2r8').setValue(rr);
        rr = 0;
        v = dijit.byId('t2r12').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r15-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r16-total').getValue();
        rr = addVal(rr, v);
        v = dijit.byId('t2r17').getValue();
        rr = addVal(rr, v);
        dijit.byId('t2r18').setValue(rr);

        rr = 0;
        var elm = dijit.byId('t2r12');
        if (elm && !isNaN(elm.getValue()))
            rr += elm.getValue();
        var elm = dijit.byId('t2r14');
        if (elm && !isNaN(elm.getValue()))
            rr -= elm.getValue();
        var elm = dijit.byId('t2r13');
        if (elm) {
            elm.setValue(rr);
        }

        var d = 0;
        v = dijit.byId('t2r18').getValue();
        d = addVal(d, v);
        elm = dijit.byId('t2r8');
        if (elm && !isNaN(elm.getValue()))
            d -= elm.getValue();
        var dIns = (d < 0) ? -d : 0;
        elm = dijit.byId('t2r19');
        if (elm) {
            elm.setValue(roundValue(dIns));
        }
        var dFss = (d < 0) ? 0 : d;
        elm = dijit.byId('t2r9');
        if (elm) {
            elm.setValue(roundValue(dFss));
        }
        rr = dFss;
        elm = dijit.byId('t2r11');
        if (elm && !isNaN(elm.getValue())) {
            rr -= elm.getValue();
        }
        var elm = dijit.byId('t2r10');
        if (elm) {
            elm.setValue(roundValue(rr));
        }
    }

    if (tId == 't3') {
        calc2015t3c3();
        calc2015t3c4();
        calc2016t3c5();
    }

    if (tId == 't4') {
        var rr = 0;
        var elm = dijit.byId('t4r1c' + crNumber);
        if (elm && !isNaN(elm.getValue()))
            rr += elm.getValue();
        elm = dijit.byId('t4r2c' + crNumber);
        if (elm && !isNaN(elm.getValue()))
            rr -= elm.getValue();
        elm = dijit.byId('t4r3c' + crNumber);
        if (elm && !isNaN(elm.getValue()))
            rr -= elm.getValue();
        dijit.byId('t4r4c' + crNumber).setValue(rr);
    }

    if (tId == 't7_1') {
        var rr=0;
        var row3 = dijit.byId('t7_1r3c' + crNumber);
        var row2 = dijit.byId('t7_1r2c' + crNumber);
        if((row3 && !isNaN(row3.getValue())) && (row2 && !isNaN(row2.getValue()) && row2 != 0)){
            rr = (row3 / row2) * 100;
            dijit.byId('t7_1r4c' + crNumber).setValue(rr);
        }
    }
//    t7_2r3
    if (tId == 't7_2') {
        var res=0;
        var row2 = dijit.byId('t7_2r2' + crNumber);
        var row1 = dijit.byId('t7_2r1' + crNumber);
        if((row2 && !isNaN(row2.getValue())) && (row1 && !isNaN(row1.getValue()) && row1 != 0)){
            res = (row2 / row1) * 100;
            dijit.byId('t7_2r3' + crNumber).setValue(res);
        }
    }
    if (tId == 't7_3') {
        var res = 0;
        var sum = 0;
        var row1 = dijit.byId('t7_3r1c' + crNumber);
        sum = addElmValue(sum, "t7_3r2c" + crNumber);
        sum = addElmValue(sum, "t7_3r3c" + crNumber);
        sum = addElmValue(sum, "t7_3r4c" + crNumber);
        if(row1 && !isNaN(row1.getValue()) && row1 != 0) {
            res = (sum / row1) * 100;
            dijit.byId('t7_3r5c' + crNumber).setValue(res);
        }
    }
    if (tId == 't8') {
        var res = 0;
        if (crNumber != '6' && crNumber != '9' && crNumber != '15') {
            var elm = dijit.byId('t8r4c' + crNumber);
            if (elm && !isNaN(elm.getValue()))
                res += elm.getValue();
            var elm = dijit.byId('t8r5c' + crNumber);
            if (elm && !isNaN(elm.getValue()))
                res += elm.getValue();
            if (dijit.byId('t8r3c' + crNumber))
                dijit.byId('t8r3c' + crNumber).setValue(res);
        }
        var sums = [0, 0, 0];
        for (var i = 1; i <= 5; i++) {
            for (var j = 0; j <= 2; j++) {
                res = 0;
                for (var k = 0; k <= 4; k++) {
                    var elm = dijit.byId('t8r' + i + 'c' + (6 + k * 3 + j));
                    if (elm && !isNaN(elm.getValue()))
                        res += elm.getValue();
                }
                dijit.byId('t8r' + i + 'c' + (j + 3)).setValue(res);
                if (i != 4 && i != 5) {
                    sums[j] += res;
                }
            }
        }

        var idx = [1, 2, 3, 6];
        res = 0;
        for (var i=0; i < idx.length; i++) {
            res = addElmValue(res, dijit.byId("t8r"+ idx[i] +"c3"));
        }
        dijit.byId("t8r8c3").setValue(res)

        idx = [1, 2, 3, 6, 7];
        res = 0;
        for (var i=0; i < idx.length; i++) {
            res = addElmValue(res, dijit.byId("t8r"+ idx[i] +"c5"));
        }
        dijit.byId("t8r8c5").setValue(res)

        idx = [1, 2, 3];
        res = 0;
        for (var i=0; i < idx.length; i++) {
            res = addElmValue(res, dijit.byId("t8r" + idx[i] + "c6"));
        }
        dijit.byId("t8r8c6").setValue(res)

        idx = [1, 2, 3];
        res = 0;
        for (var i=0; i < idx.length; i++) {
            res = addElmValue(res, dijit.byId("t8r"+ idx[i] +"c8"));
        }
        dijit.byId("t8r8c8").setValue(res)

        idx = [1, 2, 3];
        res = 0;
        for (var i=0; i < idx.length; i++) {
            res = addElmValue(res, dijit.byId("t8r"+ idx[i] +"c9"));
        }
        dijit.byId("t8r8c9").setValue(res)

        idx = [1, 2, 3];
        res = 0;
        for (var i=0; i < idx.length; i++) {
            res = addElmValue(res, dijit.byId("t8r"+ idx[i] +"c11"));
        }
        dijit.byId("t8r8c11").setValue(res)

        res = addElmValue(0, dijit.byId("t8r1c12"));

        dijit.byId("t8r8c12").setValue(res)

        res = addElmValue(0, dijit.byId("t8r1c14"));

        dijit.byId("t8r8c14").setValue(res)

        idx = [1, 2, 3];
        res = 0;
        for (var i=0; i < idx.length; i++) {
            res = addElmValue(res, dijit.byId("t8r"+ idx[i] +"c15"));
        }
        dijit.byId("t8r8c15").setValue(res)

        idx = [1, 2, 3];
        res = 0;
        for (var i=0; i < idx.length; i++) {
            res = addElmValue(res, dijit.byId("t8r"+ idx[i] +"c17"));
        }
        dijit.byId("t8r8c17").setValue(res)

        idx = [1, 2];
        res = 0;
        for (var i=0; i < idx.length; i++) {
            res = addElmValue(res, dijit.byId("t8r"+ idx[i] +"c18"));
        }
        dijit.byId("t8r8c18").setValue(res)

        idx = [1, 2];
        res = 0;
        for (var i=0; i < idx.length; i++) {
            res = addElmValue(res, dijit.byId("t8r"+ idx[i] +"c20"));
        }
        dijit.byId("t8r8c20").setValue(res)
    }

    if (tId == 't10_1') { // cr >= 3 && cr <=6
        if (crNumber > '2' && crNumber < '7') {
            var rr = 0;
            rr = addElmValue(rr, 't10_1r2c' + crNumber);
            rr = addElmValue(rr, 't10_1r3c' + crNumber);
            if (dijit.byId('t10_1r1c' + crNumber))
                dijit.byId('t10_1r1c' + crNumber).setValue(rr);
        } else {
            var v1 = isNaN(dijit.byId('t10_1r6c3').value) ? 0 : dijit.byId('t10_1r6c3').getValue();
            var v2 = isNaN(dijit.byId('t10_1r7c3').value) ? 0 : dijit.byId('t10_1r7c3').getValue();
            if (!isNaN(dijit.byId('t10_1r5c3').value)) {
                dijit.byId('t10_1r9c3').setValue(dijit.byId('t10_1r5c3').getValue() * (1 - v1 / 100 + v2 / 100));
            } else {
                dijit.byId('t10_1r9c3').setValue(0);
            }
        }
    }

    if (tId == 't10_2') {
        var rr = 0;
        rr = addElmValue(rr, 't10_2r2_1');
        rr = addElmValue(rr, 't10_2r2_2');
        rr = addElmValue(rr, 't10_2r2_3');
        if (dijit.byId('t10_2r2-sum'))
            dijit.byId('t10_2r2-sum').setValue(rr);
        rr = addElmValue(rr, 't10_2r2-begin');
        if (dijit.byId('t10_2r2-total'))
            dijit.byId('t10_2r2-total').setValue(rr);
        rr = 0;
        rr = addElmValue(rr, 't10_2r1');
        rr = addElmValue(rr, 't10_2r2-total');
        rr = addElmValue(rr, 't10_2r3');
        rr = addElmValue(rr, 't10_2r4');
        rr = addElmValue(rr, 't10_2r5');
        rr = addElmValue(rr, 't10_2r6');
        rr = addElmValue(rr, 't10_2r7');
        if (dijit.byId('t10_2r8'))
            dijit.byId('t10_2r8').setValue(rr);
        rr = 0;
        rr = addElmValue(rr, 't10_2r11_1');
        rr = addElmValue(rr, 't10_2r11_2');
        rr = addElmValue(rr, 't10_2r11_3');
        if (dijit.byId('t10_2r11-sum'))
            dijit.byId('t10_2r11-sum').setValue(rr);
        rr = addElmValue(rr, 't10_2r11-begin');
        if (dijit.byId('t10_2r11-total'))
            dijit.byId('t10_2r11-total').setValue(rr);
        rr = 0;
        rr = addElmValue(rr, 't10_2r12_1');
        rr = addElmValue(rr, 't10_2r12_2');
        rr = addElmValue(rr, 't10_2r12_3');
        if (dijit.byId('t10_2r12-sum'))
            dijit.byId('t10_2r12-sum').setValue(rr);
        rr = addElmValue(rr, 't10_2r12-begin');
        if (dijit.byId('t10_2r12-total'))
            dijit.byId('t10_2r12-total').setValue(rr);
        rr = 0;
        rr = addElmValue(rr, 't10_2r10');
        rr = addElmValue(rr, 't10_2r11-total');
        rr = addElmValue(rr, 't10_2r12-total');
        rr = addElmValue(rr, 't10_2r13');
        if (dijit.byId('t10_2r14'))
            dijit.byId('t10_2r14').setValue(rr);

        var d = 0;
        v = dijit.byId('t10_2r14').getValue();
        d = addVal(d, v);
        elm = dijit.byId('t10_2r8');
        if (elm && !isNaN(elm.getValue()))
            d -= elm.getValue();
        var dIns = (d < 0) ? -d : 0;
        elm = dijit.byId('t10_2r15');
        if (elm) {
            elm.setValue(roundValue(dIns));
        }
        rr = 0;
        var row1 = dijit.byId('t10_2r9').getValue();
        var row3 = dijit.byId('t10_2r9_2').getValue();
        elm = dijit.byId('T7P10');
        if (elm && !isNaN(row1) && !isNaN(row3)) {
            rr = row1 - row3;
            rr = (rr < 0) ? 0 : rr;
            elm.setValue(roundValue(rr));
        }
        rr = 0;
        row1 = dijit.byId('t10_2r10').getValue();
        row3 = dijit.byId('t10_2r10_2').getValue();
        elm = dijit.byId('t10_2r10_1');
        if (elm && !isNaN(row1) && !isNaN(row3)) {
            rr = row1 - row3;
            rr = (rr < 0) ? 0 : rr;
            elm.setValue(roundValue(rr));
        }
    }

    if(tId=="t11_1") {
        var res = addElmValue(0, "t11_1r1c2");
        res = addElmValue(res, "t11_1r4c2");
        res = addElmValue(res, "t11_1r7c2");
        res = addElmValue(res, "t11_1r9c2");
        elm = dijit.byId('t11_1r10c2');
        if (elm) {
            elm.setValue(res);
        }
    }

    if(tId == "t11_2"){
        var res = addElmValue(0, "t11_2r1");
        //res = addElmValue(res, "t11_2r2");
        res = addElmValue(res, "t11_2r3");
        elm = dijit.byId('t11_2r4');
        if (elm) {
            elm.setValue(res);
        }
    }

}

function calc2012(tId, crNumber) {
    if (tId == 't6_1') {
        if (dijit.byId('t6_1r1c' + crNumber).value != '' && dijit.byId('t6_1r1c' + crNumber).value != '0') {
            dijit.byId('t6_1r3c' + crNumber).setValue(dijit.byId('t6_1r2c' + crNumber).value * 100 / dijit.byId('t6_1r1c' + crNumber).value);
        }
    }
    if (tId == 't6_2') {
        if (dijit.byId('t6_2r1c' + crNumber).value != '' && dijit.byId('t6_2r1c' + crNumber).value != '0') {
            dijit.byId('t6_2r3c' + crNumber).setValue(dijit.byId('t6_2r2c' + crNumber).value * 100 / dijit.byId('t6_2r1c' + crNumber).value);
        }
        if (dijit.byId('t6_2r4c' + crNumber).value != '' && dijit.byId('t6_2r4c' + crNumber).value != '0') {
            dijit.byId('t6_2r6c' + crNumber).setValue(dijit.byId('t6_2r5c' + crNumber).value * 100 / dijit.byId('t6_2r4c' + crNumber).value);
        }
    }
    if (tId == 't7_1') {
        if (dijit.byId('t7_1r2c' + crNumber).value != '' && dijit.byId('t7_1r2c' + crNumber).value != '0') {
            dijit.byId('t7_1r4c' + crNumber).setValue(dijit.byId('t7_1r3c' + crNumber).value * 100 / dijit.byId('t7_1r2c' + crNumber).value);
        }
    }
    if (tId == 't7_2') {
        if (dijit.byId('t7_2r1').value != '' && dijit.byId('t7_2r1').value != '0') {
            dijit.byId('t7_2r3').setValue(dijit.byId('t7_2r2').value * 100 / dijit.byId('t7_2r1').value);
        }
    }
    if (tId == 't7_3') {
        if (dijit.byId('t7_3r1c' + crNumber).value != '' && dijit.byId('t7_3r1c' + crNumber).value != '0') {
            var rr = 0;
            rr = addElmValue(rr, 't7_3r2c' + crNumber);
            rr = addElmValue(rr, 't7_3r3c' + crNumber);
            rr = addElmValue(rr, 't7_3r4c' + crNumber);
            dijit.byId('t7_3r5c' + crNumber).setValue(rr * 100 / dijit.byId('t7_3r1c' + crNumber).value);
        }
    }
}

function calcF4A(tId) {
    if (tId == 't2') {
        var rr = 0;
        for (var i = 1; i <= 12; i++) {
            rr = addElmValue(rr, 't2r' + i + 'c6');
        }
        if (dijit.byId('t2r13c6'))
            dijit.byId('t2r13c6').setValue(rr);
    }
    if (tId == 't3') {
        var rr = 0;
        rr = addElmValue(rr, 't3r4c3');
        rr = addElmValue(rr, 't3r5c3');
        if (dijit.byId('t3r3c3'))
            dijit.byId('t3r3c3').setValue(rr);
        rr = 0;
        rr = addElmValue(rr, 't3r1c3');
        rr = addElmValue(rr, 't3r2c3');
        rr = addElmValue(rr, 't3r3c3');
        rr = addElmValue(rr, 't3r6c3');
        rr = addElmValue(rr, 't3r7c3');
        rr = addElmValue(rr, 't3r8c3');
        if (dijit.byId('t3r9c3'))
            dijit.byId('t3r9c3').setValue(rr);
    }
}

function calc2010(tId, crNumber) {

}

function addVal(res, v) {
    if (!isNaN(v))
        res += v;
    return res;
}

function addElmValue(res, elmId) {
    var elm = dijit.byId(elmId);
    if (elm && !isNaN(elm.getValue()))
        res += elm.getValue();
    return res;
}

// warn move to js !!!
function getActionUri(aUri) {
    //var actionUri = '$vc.getAppUri()' + "/" + aUri;
    var actionUri = vc_getAppUri + "/" + aUri;
    //alert('actionUri=' + actionUri);
    return actionUri;
}
//
function doLogout() {
    document.location.href = getActionUri('logout');
}
function doLogin() {
    document.getElementById("lf").submit();
}
function reLogin() {
    var urlQ = getActionUri('relogin&user=' + dijit.byId('user').getValue() + '&pwd=' + dijit.byId('pwd').getValue());
    //alert(urlQ);
    dojo.xhrPost({
        url: urlQ,
        load: function(data) {
            reloadPage();
        },
        error: function(error) {
            alert(getAuthErr());
        }
    });
}
// standard function - util
function standardServerPost(frmID, divResId, uri) {
    dojo.xhrPost({
        divResultId: divResId,
        url: uri,
        load: standardServerCallback,
        error: standardServerError,
        form: frmID
    });
}
function servPost(frmID, divResId, uri, fLoad, fErr) {
    dojo.xhrPost({
        divResultId: divResId,
        url: uri,
        load: fLoad,
        error: fErr,
        form: frmID
    });
}
function servPost1(frmID, divResId, uri, fLoad, fErr) {
    return dojo.xhrPost({
        divResultId: divResId,
        url: uri,
        load: fLoad,
        error: fErr,
        form: frmID
    });
}
//sync:true
function servPostSync(frmID, divResId, uri, fLoad, fErr) {
    dojo.xhrPost({
        divResultId: divResId,
        url: uri,
        load: fLoad,
        error: fErr,
        form: frmID,
        sync: true
    });
}
// standard function - util
function standardServerPost(frmID, divResId, uri) {
    dojo.xhrPost({
        divResultId: divResId,
        url: uri,
        load: standardServerCallback,
        error: standardServerError,
        form: frmID
    });
}
function standardServerCallback(data, ioArgs) {
    dijit.byId(ioArgs.args.divResultId).attr('content', data);
    clearLoadIndicator('loadP');
//alert(ioArgs.args.url);
}
function standardServerError() {/*alert error*/
}

function displayContextHelp() {
    var cTitle = "&nbsp;";
    var cHelp = "На этой вкладке нет пояснений";
    try {
        var cTxt = dojo.byId('contextHelp').innerHTML;
        var cL = cTxt.length;
        var width = (cL < 500) ? '400px' : '760px';
        var height = (cL < 500) ? '100px' : '500px';
        cHelp = '<div class="cHelpContainer" style="width:' + width + ';height:' + height + ';overflow-y:auto;">' + dojo.byId('contextHelp').innerHTML + '</div>';
        if (cHelp != null)
            cTitle = "Помощь";
    }
    catch (e) {
    }
    var contextHelpDlg = dijit.byId('contextHelpDlg');
    contextHelpDlg.set('title', cTitle);
    contextHelpDlg.set('content', cHelp);
    contextHelpDlg.show();
}
//
function submitenter(myfield, e) {
    var keycode;
    if (window.event)
        keycode = window.event.keyCode;
    else if (e)
        keycode = e.which;
    else
        return true;
    if (keycode == 13) {
        myfield.form.submit();
        return false;
    } else
        return true;
}

function setMinDate2(date1, dateId2) {
    /*  var date2 = dijit.byId(dateId2);
     if (date1) {
     date2.constraints.min = date1;
     date2.validate();
     }    */
}

function setMaxDate1(date2, dateId1) {
    /* var date1 = dijit.byId(dateId1);
     if (date2) {
     date1.constraints.max = date2;
     date1.validate();
     }  */
}

function addRow(tId) {
    var table_to_change = document.getElementById("table_to_change");
    var idx = table_to_change.rows.length;
    //lastRowIndex++;
    var onchangeText = "";

    var tr = table_to_change.insertRow(idx - 1);
    if (!document.getElementById(tId + 'lastRowIndex').value) {
        var lastId;
        for (var i = table_to_change.rows.length - 1; i > 0; i--) {
            if (table_to_change.rows[i].id.indexOf("row") == 0) {
                lastId = table_to_change.rows[i].id.substr(3);
                break;
            }
        }
        if (lastId) {
            document.getElementById(tId + 'lastRowIndex').value = lastId;
        } else {
            document.getElementById(tId + 'lastRowIndex').value = 1;
        }
    }
    var newId = parseInt(document.getElementById(tId + 'lastRowIndex').value) + 1; // ид. для новой строки
    tr.id = 'row' + newId;
    var td = tr.insertCell(0); // Ячейка для "Номер п/п"
    td.className = 'centered';
    var defRowsCount;

    //if ((tId == 't5') || (tId == 't13') || (tId == 't15')) {

    // сколько строк занимает заголовок таблицы, обычно включает заголовки и строку с номерами столбцов
    if ((tId == 't7_4') || (tId == 't13') ||  (tId == 't15')) {
        defRowsCount = 4;
    } else if (tId == 't16') // Таблица 6.1
    {
        defRowsCount = 5;
    }
    else {
        defRowsCount = 2;
    }
    var rId = idx - defRowsCount; // идентификатор новой строки таблицы
    td.innerHTML = rId + "&nbsp;<img align='top' onclick='removeRow(&#39;" + tId + "&#39;,&#39;" + tr.id + "&#39;);' src='" + vc_cp + "/img/delete.gif' title='Удалить'>";
    var inputType;

    if (tId == 't5') {
        for (var i = 2; i <= 5; i++) {
            var td = tr.insertCell(i - 1);
            td.className = 'centered';
            classStr = "myField";
            var requiredField = " required='true' ";
            inputType = "dijit.form.ValidationTextBox";    
            if (i == 2) {
                classStr = "myMedium";
                td.noWrap = true;
                td.innerHTML = "<input name='t5r" + newId + "c0" + "' id='t5r" + newId + "c0" + "' tabindex='" + ((newId) * 7 + 1) + "' regExp='.{0,30}'" + requiredField + " value='' dojoType='" + inputType + "' class='" + classStr + "'/>";
                td.innerHTML += "<input name='t5r" + newId + "c1" + "' id='t5r" + newId + "c1" + "' tabindex='" + ((newId) * 7 + 2) + "' regExp='.{0,30}'" + requiredField + " value='' dojoType='" + inputType + "' class='" + classStr + "'/>";
                td.innerHTML += "<input name='t5r" + newId + "c2" + "' id='t5r" + newId + "c2" + "' tabindex='" + ((newId) * 7 + 3) + "' regExp='.{0,30}'" + " value='' dojoType='" + inputType + "' class='" + classStr + "'/>";
            } 
            
            if (i == 3) {
                td.innerHTML = "<input name='t5r" + newId + "c3" + "' id='t5r" + newId + "c3" + "' tabindex='" + ((newId) * 7 + 4) + "' regExp='\\d{12,12}'" + " value='' dojoType='" + inputType + "' class='" + classStr + "'/>";
            }
            if (i == 4) {
                td.innerHTML = "<input name='t5r" + newId + "c4" + "' id='t5r" + newId + "c4" + "' tabindex='" + ((newId) * 7 + 5) + "' regExp='^\\d{3}-\\d{3}-\\d{3} \\d{2}'" + " value='' dojoType='" + inputType + "' class='" + classStr + "'/>";
            }
            if (i == 5) {
                td.innerHTML = "<select name='t5r" + newId + "c5" + "' id='t5r" + newId + "c5" + "' tabindex='" + ((newId) * 7 + 6) + requiredField + " class='" + classStr + "'>" 
                        + "<option value=''></option>" 
                        + "</select>";
            
            var sel_1=document.getElementById("template");
            var sel_2=document.getElementById("t5r" + newId + "c5");
            for (var i=0; i < sel_1.options.length; i++) {
		        sel_2.options[i] = new Option(sel_1.options[i].text, sel_1.options[i].value);
                sel_2.options[i].selected = sel_1.options[i].selected;
            }
            }
        }
/*
//        var td = tr.insertCell(1);
//        td.noWrap = true;
//        for (var i = 0; i <= 2; i++) {
//            // td.style.paddingTop = 5;
//            //td.className = 'centered';
//            switch (i) {
//                case 0:
//                    inputType = "dijit.form.ValidationTextBox";
//                    break;
//                case 1:
//                    inputType = "dijit.form.ValidationTextBox";
//                    break;
//                case 2:
//                    inputType = "dijit.form.ValidationTextBox";
//                    break;
//            }
//            var requiredField = "";
//            if (i == 0 || i == 1) {
//                requiredField = " required='true'";
//            }
//            var classStr = "myMedium";
//            td.innerHTML += "<input name='t5r" + newId + "c" + i + "' id='t5r" + newId + "c" + i + "' regexp='.{0,30}' tabindex='" + ((newId) * 9 + i) + "' value='' " + onchangeText + " dojoType='" + inputType + "' class='" + classStr + "'" + requiredField + "/>&nbsp;";
//        }
//        for (var i = 3; i <= 8; i++) {
//            var td = tr.insertCell(i - 1);
//            // td.style.paddingTop = 5;
//            td.className = 'centered';
//            switch (i) {
//                case 3:
//                    inputType = "dijit.form.DateTextBox";
//                    break;
//                case 4:
//                    inputType = "dijit.form.DateTextBox";
//                    break;
//                default:
//                    inputType = "dijit.form.CurrencyTextBox";
//            }
//            var onchangeText = "";
//            if (i == 3) {
//                onchangeText = "onchange='setMinDate2(arguments[0], &#39;t5r" + newId + "c4&#39;)'";
//            }
//            if (i == 4) {
//                onchangeText = "onchange='setMaxDate1(arguments[0], &#39;t5r" + newId + "c3&#39;)'";
//            }
//            if (i >= 5) {
//                onchangeText = "onchange='calc(&#39;t5&#39;,&#39;" + i + "&#39;)' currency='RUR'";
//            }
//            var requiredField = "";
//            if (i == 3 || i == 4) {
//                requiredField = " required='true'";
//            }
//            var classStr;
//            if (i == 3 || i == 4) {
//                classStr = "myMedium";
//            }
//            else {
//                classStr = "myField";
//            }
//
//            td.innerHTML = "<input name='t5r" + newId + "c" + i + "' id='t5r" + newId + "c" + i + "' tabindex='" + ((newId) * 9 + i) + "' value='' " + onchangeText + " dojoType='" + inputType + "' class='" + classStr + "'" + requiredField + "/>";
//        }
*/
    } else
    if (tId == 't13') {
        for (var i = 2; i <= 16; i++) {
            var td = tr.insertCell(i - 1);
            // td.style.paddingTop = 5;
            td.className = 'centered';
            switch (i) {
                case 2:
                    //inputType = "dijit.form.ValidationTextBox";
                    inputType = "fssExt.OkvedField";
                    break;
                case 3:
                case 4:
                case 5:
                case 6:
                    inputType = "dijit.form.NumberTextBox";
                    break;
                default:
                    inputType = "dijit.form.CurrencyTextBox";
            }
            var requiredField = "";
            if (i == 2 || i == 3 || i == 4) {
                requiredField = " required='true'";
            }
            var regExpAttr = "";
            //var invalidMsgAttr="";
            //if (i==2) {
            //regExpAttr=" regExp='.{0,8}'";
            //regExpAttr=" regExp='^\\d{1,2}(\\.\\d{1,2})?(\\.\\d{1,2})?'"; //from FormValidators class
            //invalidMsgAttr=" invalidMessage='Правильный формат ОКВЭД: XX.XX.XX'";//from FormValidators class
            //} else 
            if (i == 4) {
                regExpAttr = " constraints='{min:0,max:99,places:\"0,1\"}'";
            } else if (i == 3 || i == 5 || i == 6) {
                regExpAttr = " constraints='{min:0,max:99,places:0}'";
            }
            var classType;
            switch (i) {
                case 2:
                case 3:
                case 4:
                case 5:
                case 6:
                    classType = "myShortField";
                    break;
                default:
                    classType = "myField";
            }
            td.innerHTML = "<input name='t13r" + newId + "c" + i + "' id='t13r" + newId + "c" + i + "' tabindex='" + ((newId) * 15 + i) + "' value='' dojoType='" + inputType + "' class='" + classType + "'" + requiredField + regExpAttr + "/>";
        }
    } else
    if (tId == 't16') { // Таблица 6.1 (новая для XSD 0.9)
        var t16_tabIndex_offset = 1000; // Первый номер табуляции, зарезервированный для таблицы t16 (Т.6.1)
        var t16_cell_num = 14;
        var appendix;
        // Начинаем с двойки, т.к. 1-я ячейка уже занята "Номер п/п"
        for (var i = 2; i <= 15; i++) {
            var td = tr.insertCell(i - 1);
            // td.style.paddingTop = 5;
            td.className = 'centered';
            switch (i) {
                case 2: // REG_NUM_P
                    appendix = "required='true' dojoType='fssExt.RegNumField' class='myMedium'";
                    break;
                case 3: // INN_P
                    appendix = "required='true' dojoType='ValidationTextBoxINN' class='myMedium'";
                    break;
                case 4:
                    appendix = "required='true' dojoType='fssExt.OkvedField' class='myShortField'";
                    break;
                case 5:
                    appendix = "required='true' dojoType='dijit.form.NumberTextBox' class='myShortField'";
                    break;
                case 6:
                case 7:
                case 8:
                case 9:
                case 10:
                case 11:
                case 12:
                case 13:
                    appendix = "constraints='{min:0,max:99999999.99,places:2}' dojoType='dijit.form.CurrencyTextBox' currency='RUR' class='myShortField'";
                    break;
                case 14:
                case 15:
                    appendix = "required='true' constraints=\"{min:0,max:99,places:'0,1'}\" dojoType='fss.PercNumberTextBox' class='myShortField'";
                    break;
                default:
                    appendix = "";
            }
            td.innerHTML = "<input name='t16r" + rId + "c" + i + "' id='t16r" + rId + "c" + i + "' tabindex='" + ( rId * t16_cell_num + (i-1) + t16_tabIndex_offset) + "' value='' " + appendix + "/>";
        }
    } else
    if ((tId == 't9') || (tId == 't12')) {
        for (var i = 2; i <= 5; i++) {
            var td = tr.insertCell(i - 1);
            if (i < 4) {
                td.className = 'centered';
            }
            if (i == 2 || i == 3 || i == 4)
                requiredField = " required='true'";
            // td.style.paddingTop = 5;
            // td.className = 'left';
            switch (i) {
                case 2:
                    inputType = "dijit.form.ValidationTextBox";
                    break;
                case 3:
                    inputType = "dijit.form.DateTextBox";
                    break;
                default:
                    inputType = "dijit.form.CurrencyTextBox";
            }
            if (i == 5) {
                td.innerHTML = "&nbsp;";
            }
            else {
                td.innerHTML = "<input name='" + tId + "r" + newId + "c" + i + "' id='" + tId + "r" + newId + "c" + i + "' tabindex='" + ((newId) * 3 + i) + "' value='' dojoType='" + inputType + "' class='myField'" + requiredField + "/>";
            }
        }
    } else
    if (tId == 't7_4') {// Таблица 4.5
        for (var i = 2; i <= 9; i++) {
            var td = tr.insertCell(i - 1);
            classStr = "myField";

            var maxLength = "";
            var requiredField = "";

            if (i == 2) {
                inputType = "dijit.form.ValidationTextBox";
                maxLength = "maxlength='13'";
                requiredField = " required='true'";
            } else if (i == 4 || i == 5) {
                inputType = "dijit.form.DateTextBox";
                requiredField = " required='true'";
            } else {
                inputType = "dijit.form.CurrencyTextBox";
            }

            if (i == 3) {
                //var newName = 't7_4r' + newId + 'c' + i;
                var newNameQuotted = '"' + 't7_4r' + newId + 'c' + (i - 2) + '"';
                td.innerHTML = "<span style='white-space:nowrap;'>";
                td.innerHTML += "<input tabindex='" + ((newId) * 8 + (i - 2)) + "' id='t7_4r" + newId + "c1' name='t7_4r" + newId + "c1' dojoType='dijit.form.ValidationTextBox' readonly='true' required='true' class='myField' style='background:#fff !important;color:#444 !important;border:1px solid #B3B3B3 !important;margin-right:2px !important'/>";
                td.innerHTML += "<span class='clearFieldBtn' style='margin-right:4px !important' onclick='clearPatentCode(" + newNameQuotted + ")' title='Очистить'>&nbsp;</span>";
                td.innerHTML += "<span class='editFieldBtn' onclick='selectPatentCode(" + newNameQuotted + ")' title='Выбрать'></span>";
                td.innerHTML += "</span>";
            } else {
                td.innerHTML = "<input tabindex='" + ((newId) * 8 + (i - 2)) + "' name='t7_4r" + newId + "c" + (i - 2) + "' id='t7_4r" + newId + "c" + (i - 2) + "' tabindex='" + ((newId) * 19 + (i - 2)) + "' value='' " + onchangeText + " dojoType='" + inputType + "' class='" + classStr + "'" + requiredField + ' ' + maxLength + "/>";
            }
        }

    }
    document.getElementById(tId + 'lastRowIndex').value = newId;
    dojo.parser.parse("contentTable");
}

/**
 * Удаление заданной строки таблицы с указанным префиксом
 * @param tId строка c именем таблицы, например 't15' или 't16'
 * @param rowId идентификатор столбца, например
 */
function removeRow(tId, rowId) {
    var row = document.getElementById(rowId);
    var index = row.rowIndex;
    var table_to_change = document.getElementById('table_to_change');
    if (!document.getElementById(tId + 'lastRowIndex').value) {
        var lastId;
        for (var i = table_to_change.rows.length - 1; i > 0; i--) {
            if (table_to_change.rows[i].id.indexOf("row") == 0) {
                lastId = table_to_change.rows[i].id.substr(3);
                break;
            }
        }
        if (lastId) {
            document.getElementById(tId + 'lastRowIndex').value = lastId;
        } else {
            document.getElementById(tId + 'lastRowIndex').value = 1;
        }
    }
    // Add row if 0 left
    var lRows = table_to_change.rows.length;

    table_to_change.deleteRow(row.rowIndex);
    var defRowsCount;
    if ((tId == 't7_4') || (tId == 't13')) {
        defRowsCount = 3;
    } else if ((tId == 't16')) {
        defRowsCount = 4;
    } else {
        defRowsCount = 1;
    }
    for (var i = index; i < table_to_change.rows.length - 1; i++) {
        var tr = table_to_change.rows[i];
        tr.cells[0].innerHTML = (i - defRowsCount) + tr.cells[0].innerHTML.substr(tr.cells[0].innerHTML.indexOf('&nbsp;'));
    }
    if (!document.getElementById(tId + 'deletedRows').value) {
        document.getElementById(tId + 'deletedRows').value = rowId.substr(3);
    } else {
        document.getElementById(tId + 'deletedRows').value += "," + rowId.substr(3);
    }
    
    //
    dojo.parser.parse("contentTable");
}

function clearTable(auth, tId) {
    if (auth) {
        actionPrefix = "services/formfour-t";
    } else {
        actionPrefix = "f4input-t";
    }
    if (tId == '7') {
        //Save entire tab first
        servPost('reportForm', 'contentTable', getActionUri(actionPrefix + '?t=t' + tId + "&ct=t" + tId + "&h=" + Math.random()), function() {
            standardServerPost('reportForm', 'contentTable', getActionUri(actionPrefix + '?t=t' + tId + "&ct=t" + tId + "&h=" + Math.random() + "&clear=t7_4"));
        });
        //standardServerPost('reportForm', 'contentTable', getActionUri(actionPrefix + '?t=t' + tId + "&ct=t" + tId + "&h=" + Math.random() + "&clear=t7_4"));
    } else {
        if (tId == '5') {
        //Save entire tab first
        servPost('reportForm', 'contentTable', getActionUri(actionPrefix + '?t=t' + tId + "&ct=t" + tId + "&h=" + Math.random()), function() {
            standardServerPost('reportForm', 'contentTable', getActionUri(actionPrefix + '?t=t' + tId + "&ct=t" + tId + "&h=" + Math.random() + "&clear=t5"));
        });
        //standardServerPost('reportForm', 'contentTable', getActionUri(actionPrefix + '?t=t' + tId + "&ct=t" + tId + "&h=" + Math.random() + "&clear=t7_4"));
    } else {
        standardServerPost('reportForm', 'contentTable', getActionUri(actionPrefix + '?t=t' + tId + "&ct=t" + tId + "&h=" + Math.random() + "&clear=t" + tId));
        }
    }
}


// Passwd fields comparison
function areEquals(dojoTxt1, dojoTxt2) {
    return dojoTxt1.getValue() == dojoTxt2.getValue() && dojoTxt2.getValue() != "";
}

//
function dldF4InputCallback(data, ioArgs) {
    //alert('dldF4InputCallback');
    //if(ioArgs.args.url.indexOf('dldtype=f4input')!=-1){
    standardServerCallback(data, ioArgs);
//document.location.href = "/dld?type=f4input";
//window.open("/dld?type=f4input");
}
function dldF4Callback(data, ioArgs) {
    //alert('dldF4InputCallback');
    standardServerCallback(data, ioArgs);
//document.location.href = "/dld?type=f4";
//window.open("/dld?type=f4");
}
// for test
function dldF4Input(tabsCount) {
    var prettyXMLFormat = dijit.byId('prettyXMLFormat').get('checked');
    var tId = getSelectedTab(tabsCount);
    if (isValidCurTab(tabsCount, tId)) {
        //servPostSync('reportForm','contentTable',getActionUri('f4input-t?t=t'+tId+"&ct=t"+tId+"&h="+Math.random()),dldF4InputCallback,standardServerError);        
        servPostSync('reportForm', 'contentTable', getActionUri('f4input-t?t=t' + tId + "&ct=t" + tId + "&h=" + Math.random()), dldF4InputCallback, standardServerError);
        // NEW - check format !!!        
        var pr1 = servPost1('reportForm', 'contentTable', getActionUri("f4validation?type=f4_input&format=1"), function f1() {
        }, function f1Err() {
        });
        pr1.then(function(results) {
            if (results && results.indexOf("formatValidationErr") != -1) {
                validateFormFourDialog(results, "Выгрузка в XML:");
            }
            else {
                document.location.href = "/dld?type=F4_INPUT&prettyXMLFormat=" + prettyXMLFormat;
            }
        });
        // OLD CODE 
        //document.location.href = "/dld?type=F4_INPUT&prettyXMLFormat="+prettyXMLFormat;
    }
}
//
function dldF4(tabsCount, mode, type) {
    var prettyXMLFormat = dijit.byId('prettyXMLFormat').get('checked');
    var tId = getSelectedTab(tabsCount);
    var modeStr = "";
    if (mode) {
        modeStr = "&mode=" + mode;
    }
    if (isValidCurTab(tabsCount, tId)) {
        var tId = getSelectedTab(tabsCount);
        var rstateElm = document.getElementById("rstate");
        var rstate;
        if (rstateElm) {
            rstate = rstateElm.value;
        }
        var prefix;
        if (type == 'F4A') {
            prefix = 'services/formfour-a-t?t=t';
        } else {
            prefix = 'services/formfour-t?t=t';
        }
        //servPost('reportForm','contentTable',getActionUri('services/formfour-t?t=t'+tId+"&ct=t"+tId+"&h="+Math.random()+modeStr),dldF4Callback,standardServerError);
        servPostSync('reportForm', 'contentTable', getActionUri(prefix + tId + "&ct=t" + tId + "&rstate=" + encodeURIComponent(rstate) + "&h=" + Math.random() + modeStr), dldF4Callback, standardServerError);
        //         
        rstateElm = document.getElementById("rstate");
        if (rstateElm) {
            rstate = rstateElm.value;
        }
        // NEW - check format !!!        
        var pr1 = servPost1('reportForm', 'contentTable', getActionUri("f4validation?type=f4" + "&rstate=" + rstate + "&format=1"), function f1() {
        }, function f1Err() {
        });
        pr1.then(function(results) {
            if (results && results.indexOf("formatValidationErr") != -1) {
                validateFormFourDialog(results, "Выгрузка в XML:");
            }
            else {
                document.location.href = "/dld?type=" + type + "&prettyXMLFormat=" + prettyXMLFormat + "&rstate=" + encodeURIComponent(rstate);
            }
        });
        // OLD !!!
        //document.location.href = "/dld?type="+type+"&prettyXMLFormat="+prettyXMLFormat+"&rstate="+encodeURIComponent(rstate);
    }
}
//
function dldCsv(auth, m) {
    // @author KMukhin
    // Action: process the csv file download 
    // before downloading keep adding entries
    var modeStr = "";
    if (m) {
        modeStr = "&mode=" + m;
    }
    var rstateElm = document.getElementById("rstate");
    var rstate;
    if (rstateElm) {
        rstate = encodeURIComponent(rstateElm.value);
    }
    if (auth) {
        servPostSync('reportForm', 'contentTable', getActionUri('services/formfour-t?t=t5&ct=t5&rstate=' + rstate + '&h=' + Math.random() + modeStr), dldF4Callback, standardServerError);
    } else {
        servPostSync('reportForm', 'contentTable', getActionUri('f4input-t?t=t5' + "&ct=t5&h=" + Math.random()), dldF4InputCallback, standardServerError);
    }
    rstateElm = document.getElementById("rstate");
    if (rstateElm) {
        rstate = rstateElm.value;
    }
    document.location.href = vc_cp + "/dldCsv?auth=" + auth + "&rstate=" + encodeURIComponent(rstate);
}
function showCSV(rstateValue) {
    var rstateElm = document.getElementById("rstateDlg");
    if (rstateElm) {
        rstateElm.value = rstateValue;
    }
    dijit.byId("dialogLoadCSV").show();
}
// portal map
function formatMap() {
    dojo.query("#dynamicMapContainer li.portalMap").forEach(function(node, index, arr) {
        //
        if (node.children.length > 1 || index == 0) {
            setMapHover(node);
        }
    });

    dojo.query("#staticMapContainer li.portalMap").forEach(function(node) {
        setMapHover(node);
    });
}

function setMapHover(node) {
    dojo.addClass(node, "head");
    dojo.connect(node, "onmouseenter", function() {
        dojo.addClass(node, "mapSelected");
    });
    dojo.connect(node, "onmouseleave", function() {
        dojo.removeClass(node, "mapSelected");
    });
}

function switchCurrentOrg() {
    try {
        dojo.byId("formAction").value = "switchCurrentOrg";
        dojo.attr(dojo.byId("accountInfoOrgForm"), "action", vc_getAppUri + "/services/accountinfo-organizations");
    } catch (e) {
    }
    finally {
        dojo.byId("accountInfoOrgForm").submit();
    }

}

function errMess() {
    // @author KMukhin
    // Action: parse URL and if it detects "errmess" public error message 
    // alert("errMess");
    var u = window.location + "";
    var required = "errmess=";
    var mess = null;
    var pos = u.indexOf(required);
    if (pos > 0) {
        var type = u.substring(pos + 8, pos + 9);
        switch (type * 1) {
            case 1 :
                mess = "выбран не csv файл.";
                break;
            case 2 :
                mess = "файл содержит некорректные данные.";
                break;
            case 3 :
                mess = "отчёт не найден.";
                break;
        }
    }

    if (mess != null) {
        if (dijit.byId("errMess")) {
        } else {
            // show the dialog only once
            mess = "<span style='color: red;'>Ошибка: </span>" + mess;
            new dijit.Dialog({
                id: "errMess",
                content: ""
                        + "<div align='center'>"
                        + "<div style='padding: 20px;'> " + mess + "</div>"
                        + "<input label='Закрыть' dojoType='dijit.form.Button' type='button' onclick='dijit.byId(\"errMess\").hide();'>"
                        + "</div>"
            }, "").show();
        }
    }
}

/* Confirmation dialog */
function confirmDialog(title, question, callbackFn, icon24) {
    if (!icon24) {
        var icon24 = vc_cp + '/img/icons/sign_stop.png';
    }
    var errorDialog = new dijit.Dialog({
        id: 'queryDialog',
        title: title,
        onHide: dojo.hitch(this, function() {
            errorDialog.destroyRecursive();
        })
    });
    var callback = function(choice) {
        //errorDialog.destroyRecursive();
        errorDialog.hide();
        callbackFn(choice);
    };
    var txtContainer = dojo.create('div', {
        innerHTML: '<img src="' + icon24 + '" width=24 height=24 align="middle" hspace=6 vspace=6 style="margin-top:-2px !important">' + question,
        style: 'margin-bottom:10px;padding-top:10px;'
    });
    var btnContainer = dojo.create('center', {
        style: "white-space:nowrap;"
    });
    var btnYes = new dijit.form.Button(
            {
                label: 'Да',
                onClick: function() {
                    callback(true)
                }
            });
    var btnNo = new dijit.form.Button(
            {
                label: 'Нет',
                id: 'confBtnNo',
                onClick: function() {
                    callback(false)
                }
            });

    btnYes.set('class', 'myConfirmationDialog');
    btnNo.set('class', 'myConfirmationDialog');
    errorDialog.containerNode.appendChild(txtContainer);
    errorDialog.containerNode.appendChild(btnContainer);
    btnContainer.appendChild(btnYes.domNode);
    btnContainer.appendChild(btnNo.domNode);
    errorDialog.show();
}


// Pagination utils
function onPage(pN) {
    dojo.byId('p').value = pN;
    dijit.byId('filterForm').submit();
}
function prevPage(pN) {
    onPage(pN - 1);
}
function nextPage(pN) {
    onPage(pN + 1);
}

// TODO: проверить работоспособность функции
// 12-значный ИНН физического лица
function validateINN12(value) {
    if (isNaN(value) || !value || value.length != 12 ) { // todo: как быть с ИНН физ. лица из 12 цифр, а не из 10?
        return 'ИНН физ. лица должен состоять из 10 цифр.';
    }
    var coeffs = [7, 2, 4, 10, 3, 5, 9, 4, 6, 8];
    var sum = 0;

    // проверяем 1-й контрольный код
    for (var i = 0; i < value.length - 3; i++) {
        sum += parseInt(value.charAt(i)) * parseInt(coeffs[i]);
    }
    //alert('sum='+sum);
    var check = sum % 11;
    if (check == 10) {
        check = 0;
    }
    if (check != value.charAt(10)) {
        return 'Некорректный 1-й контрольный код ИНН-12.';
    }

    coeffs = [3, 7, 2, 4, 10, 3, 5, 9, 4, 6, 8];
    sum = 0;
    // проверяем 2-й контрольный код
    for (var i = 0; i < value.length - 2; i++) {
        sum += parseInt(value.charAt(i)) * parseInt(coeffs[i]);
    }
    //alert('sum='+sum);
    var check = sum % 11;
    if (check == 10) {
        check = 0;
    }
    if (check != value.charAt(11)) {
        return 'Некорректный 2-й контрольный код ИНН-12.';
    }
}

// 10-значный ИНН юр. лица
function validateINN(value) {
    if (isNaN(value) || !value || value.length != 10 ) { // todo: как быть с ИНН физ. лица из 12 цифр, а не из 10?
        return 'ИНН юр. лица должен состоять из 10 цифр.';
    }
    var coeffs = [2, 4, 10, 3, 5, 9, 4, 6, 8];
    var sum = 0;

    //value = value.split('')
    for (var i = 0; i < value.length - 1; i++) {
        sum += parseInt(value.charAt(i)) * parseInt(coeffs[i]);
    }
    //alert('sum='+sum);
    var check = sum % 11;
    if (check == 10) {
        check = 0;
    }
    if (check != value.charAt(9)) {
        return 'Некорректный контрольный код ИНН-10.';
    }
}
//
function validateKPP(value) {
    if (isNaN(value) || !value || value.length != 9) {
        return 'КПП должен состоять из 9 цифр.';
    }
}
//
function validateSnils(value) {
    if (isNaN(value) || !value || (value.length != 11)) {
        return 'СНИЛС должен состоять из 11 цифр.';
    }
    var s1 = '';
    var sum = 0;
    for (var i = 0; i < value.length - 2; i++) {
        sum += parseInt(value.charAt(i)) * (value.length - 2 - i);
        s1 += parseInt(value.charAt(i));
    }
    if (s1 < 001001998) {
        return 'Некорректный СНИЛС';
    }
    var check;
    if (sum < 100) {
        check = sum;
    } else if (sum <= 101) {
        check = '00';
    } else {
        check = sum % 101;
        if (check.length == 1) {
            check = '0' + check;
        }
    }
    // alert('check='+check);
    var yy = value.charAt(9) + value.charAt(10);

    if (check != yy) {
        return 'Некорректный СНИЛС';
    }
}

function validateOMS(value, isRequired) {
    if (isRequired) {
        if (isNaN(value) || !value || value.length != 16) {
            return 'Указано недопустимое значение, поле должно состоять из 16 цифр';
        }
    }
    //if (value.length > 0 && value.length != 16 || isNaN(parseInt(value))) {
    if (value.length != 16) {
        if (!value && !isRequired) {
            return null;
        }
        return 'Указано недопустимое значение, поле должно состоять из 16 цифр';
    }
    var s1 = '';
    var s2 = '';
    for (var i = value.length - 2; i >= 0; i--) {
        // наоборот
        if (i % 2 == 0) {
            //s1 += value[i];
            s1 += parseInt(value.charAt(i));
        } else {
            //s2 += value[i];
            s2 += parseInt(value.charAt(i));
        }
    }
    s1 *= 2;
    var s3 = s2 + s1;
    //alert('s3='+s3);
    var s4 = 0;
    for (var i = 0; i < s3.length; i++) {
        //s4 += s3[i] * 1;
        s4 += s3.charAt(i) * 1;
    }
    var check = 10 - (s4 % 10);
    //if (check != value[15]) {
    if (check != value.charAt(15)) {
        return 'Некорректный полис ОМС';
    }
}
// validation controls OFF

function checkCipher(obj) {
    var codeSet1 = new Array('121', '151', '161')
    var codeSet2 = ['141']
    var eM = 'Недопустимое значение доля второй части шифра'
    var c1Val = dijit.byId('code1').get('value')
    if (dojo.indexOf(codeSet1, c1Val) >= 0) {
        if (obj.id == 'code2' && obj.value != '01')
            alert(eM)
        dijit.byId('code2').set('value', '01')
    }

    if (dojo.indexOf(codeSet2, c1Val) >= 0) {
        if (obj.id == 'code2' && obj.value != '02')
            alert(eM)
        dijit.byId('code2').set('value', '02')
    }
}

function setStartStopDatesValidation() {
    dojo.connect(dijit.byId('dateStart'), 'onChange', function() {
        checkReportStartStopDates('dateStart')
    });
    dojo.connect(dijit.byId('dateStop'), 'onChange', function() {
        checkReportStartStopDates('dateStart')
    });
}
//
function setStartStopDateErr(id) {
    dijit.byId(id).set('state', 'Error');
    dijit.byId(id)._setStateClass();
    dijit.byId(id).displayMessage('Дата начала периода должна быть меньше даты окончания')
}

function checkReportStartStopDates(id) {
    var dateStart = dijit.byId('dateStart').get('value');
    var dateStop = dijit.byId('dateStop').get('value');
    if (dateStart != null && dateStop != null && dateStart > dateStop) {
        if (!id)
            id = 'dateStart'
        setStartStopDateErr(id);
        return false;
    } else {
        return true;
    }
}

function getPatentCode(strId) {
    //dojo.byId('requestingCellId').value=strId;
    dijit.byId('patentCodeDialog').show();
}

function setPatentCode(codeId, codeName) {
    var requestingCellId = dojo.byId('requestingCellId').value;
    //var requestingTextId = dojo.byId('requestingCellId').value+"Text";
    var codeNameShort = "[" + codeId + "] " + codeName;
    var codeNameFull = "[" + codeId + "] " + codeName;

    var maxLength = 22;
    if (codeNameShort.length > maxLength) {
        codeNameShort = codeNameShort.substr(0, maxLength) + "...";
    }
    //dijit.byId(requestingCellId).set('value', codeId);

    dojo.byId(requestingCellId).value = codeId;
    //dojo.byId(requestingTextId).innerHTML=codeNameShort;
    //dojo.byId(requestingTextId).innerHTML=codeId;
    //dojo.byId(requestingTextId).title=codeNameFull;
    dijit.byId('patentCodeDialog').hide();
}

function clearPatentCode(strId) {
    dojo.byId(strId).value = '';
    //dojo.byId(strId+"Text").innerHTML='';
}

function selectPatentCode(str) {
    dojo.byId('requestingCellId').value = str;
    dijit.byId('patentCodeListContent').set('href', getActionUri('services/formfour-patent-list'));
    dijit.byId('patentCodeDialog').show();
}

// Date utils
Date.isLeapYear = function (year) {
    return (((year % 4 === 0) && (year % 100 !== 0)) || (year % 400 === 0));
};

Date.getDaysInMonth = function (year, month) {
    return [31, (Date.isLeapYear(year) ? 29 : 28), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31][month];
};

Date.prototype.isLeapYear = function () {
    var y = this.getFullYear();
    return (((y % 4 === 0) && (y % 100 !== 0)) || (y % 400 === 0));
};

Date.prototype.getDaysInMonth = function () {
    return Date.getDaysInMonth(this.getFullYear(), this.getMonth());
};

Date.prototype.addMonths = function (value) {
    var n = this.getDate();
    this.setDate(1);
    this.setMonth(this.getMonth() + value);
    this.setDate(Math.min(n, this.getDaysInMonth()));
    return this;
};

Date.prototype.addYears = function (value) {
    var months = value*12;
    return this.addMonths(months);
};

function strToDate(ddmmyyyy) {
    return new Date(ddmmyyyy.replace(/(\d{2}).(\d{2}).(\d{4})/, "$2/$1/$3"));
}
//
function dateToStr(aDate) {
    var dd = aDate.getDate() < 10 ? '0' + aDate.getDate().toString() : aDate.getDate();
    var mm = (aDate.getMonth() + 1) < 10 ? '0' + (aDate.getMonth() + 1) : (aDate.getMonth() + 1);
    return dd + '.' + mm + '.' + aDate.getFullYear();
}
