dojo.provide('tops.form');

dojo.require("dojo.data.ItemFileReadStore");
dojo.require("dojo.io.iframe");
dojo.require("dojo.date.stamp");

tops.form.submitForm = function(formId, doCheck) {
	var checkIt = false;
	if (doCheck != null && doCheck) {
		checkIt = true;
	}
	var node = dijit.byId(formId);
	if (node != null) {
		if (checkIt) {
			if (node.validate()) {
				dojo.byId(formId).submit();
                                return true;
			} 
		} else {
			dojo.byId(formId).submit();
                        return true;
		}
	}
        return false;
};

tops.form.setFormValues = function(formCl) {
	for(var index in formCl) {
		var node = dijit.byId(index);
		if (node == null) {
			node = dojo.byId(index);
		}
	    if (node != null) {
			node.value = formCl[index];
	    }
	}				    
};

tops.form.setFormValue = function(index, value) {
	var node = dijit.byId(index);
	if (node == null) {
		node = dojo.byId(index);
	    if (node != null) {
			node.value = value;
		}				    
	} else {
		if (node instanceof dijit.form.DateTextBox && value !== '') {
			node.set('value', dojo.date.stamp.fromISOString(value));			
		} else {
			node.set('value', value);
		}
	}
};

tops.form.getFormValue = function(index, value) {
	var node = dijit.byId(index);
	if (node == null) {
		node = dojo.byId(index);
	    if (node != null) {
			return node.value;
		}				    
	} else {
		return node.get('value');
	}
	return "";
};

tops.form.dynLoadSelectOptions = function(formName, objId, url2load) {
		//alert("DynamicSelectField-=>" + dojo.formToJson(formName) );
		dojo.io.iframe.send({
			url: vc_getAppUri + "/" + url2load,
			handleAs: "html",
			content: dojo.formToObject(formName),
			preventCache: true,
			load: function(data) {
		    	//console.log("data.body.innerHTML>" + data.body.innerHTML);
		    	
		    	var optionList = dojo.fromJson(data.body.innerHTML);
		    	//console.log("data.body.innerHTML>" + optionList);
		    	
		    	obj = dijit.byId(objId);
		    	obj.set('store', new dojo.data.ItemFileReadStore( { data: optionList } ));

		    	// the first is default
		    	if (optionList.items.length > 0) {
			    	obj.set('value', optionList.items[0][optionList.identifier]);
		    	} else {
			    	obj.set('value', '');
		    	}
		    	
		    	optionList = null;
			},
			error: function(error) {
		    	//alert("DynamicSelectField: Can't load data->" + error);
			}			
		});
};

tops.form.eventBindList = function(objectId, actionNames, scriptStr) {
	for(actionName in actionNames) {
		tops.form.eventBind(objectId, actionName, scriptStr);
	};
};

tops.form.eventBind = function(objectId, actionName, scriptStr) {
	actionName = actionName.charAt(0).toUpperCase() + actionName.substring(1);

	dojo.ready(function(){
		node = dijit.byId(objectId);
		if (node != null) {
			dojo.connect(node, 'on' + actionName,
				function(){
					dojo.ready(function(){
						//alert("YYYYYYY-in>" + scriptStr);
						eval(scriptStr);	
					});
				});
		}
	});
};

tops.form._isInRangeCache = {};
tops.form.isInRange = function(/*String*/value, /*Object?*/flags){
	if ("" == value) {
		return true;
	}
	// TODO call dojox.validate.isInRange instead
	
	value = dojo.number.parse(value, flags);
	if(isNaN(value)){
		return false; // Boolean
	}
    
	// assign default values to missing paramters
	flags = (typeof flags == "object") ? flags : {};
	var max = (typeof flags.max == "number") ? flags.max : Infinity,
		min = (typeof flags.min == "number") ? flags.min : -Infinity,
		dec = (typeof flags.decimal == "string") ? flags.decimal : ".",
	
		cache = tops.form._isInRangeCache,
		cacheIdx = value + "max" + max + "min" + min + "dec" + dec
	;
	if(typeof cache[cacheIdx] != "undefined"){
		return cache[cacheIdx];
	}

	cache[cacheIdx] = !(value < min || value > max);
	return cache[cacheIdx]; // Boolean
};

tops.form.checkDateRange = function(/*String*/value, /*Object?*/flags){
	if ("" == value) {
		return true;
	}
	flags = (typeof flags == "object") ? flags : {};
	
	var dateStart_ = (typeof flags.dateStartId == "string") ? flags.dateStartId : "",
		dateStop_ = (typeof flags.dateStopId == "string") ? flags.dateStopId : "";

    var dateStartObj = dijit.byId(dateStart_); 
    var dateStopObj = dijit.byId(dateStop_); 
    if (dateStartObj == null || dateStopObj == null) {
    	return true;
    }
    
    var isValid = true;
    
    var dateStart = dateStartObj.get('value');
    var dateStop = dateStopObj.get('value');
    
    if (dateStop != null && dateStart != null && dateStop < dateStart) {
    	dateStopObj.set('state', 'Error');
    	dateStopObj.displayMessage('Дата окончания периода не может быть меньше даты начала');
        isValid = false;
    } else {
    	dateStopObj.set('state', 'Normal');
    	dateStopObj.displayMessage();
    }
    dateStopObj._setStateClass();
    return isValid;
};

//dojo.require("dijit.form.ValidationTextBox");
dojo.declare(
	"tops.form.ValidationTextBox",
	dijit.form.ValidationTextBox,
	{
		myconstraints: {},
		
		myvalidator: function(/*anything*/value, /*dijit.form.ValidationTextBox.__Constraints*/constraints){
			return true;
		},
		
		validator: function(/*anything*/value, /*dijit.form.ValidationTextBox.__Constraints*/constraints){
			var ret = this.inherited(arguments);
			if (ret) {
				return this.myvalidator(value, this.myconstraints);
			}
			return ret;
		}
	}
);

//dojo.require("dijit.form.DateTextBox");
dojo.declare(
	"tops.form.DateTextBox",
	dijit.form.DateTextBox,
	{
		myconstraints: {},
		
		myvalidator: function(/*anything*/value, /*dijit.form.ValidationTextBox.__Constraints*/constraints){
			return tops.form.checkDateRange(value, constraints);
		},
		
		validator: function(/*anything*/value, /*dijit.form.ValidationTextBox.__Constraints*/constraints){
			var ret = this.inherited(arguments);
			if (ret) {
				return this.myvalidator(value, this.myconstraints);
			}
			return ret;
		}
	}
);



dojo.require("tops.form");
