dojo.require("dijit.form.CheckBox");
/////////////////////////////
try {
    dojo.extend(dijit._Widget, {
        sickListWidget: "",
        slValue: ""
    });
    dijit._Widget.prototype.attributeMap.sickListWidget = "";
    dijit._Widget.prototype.attributeMap.slValue = "";
} catch (e) {
//alert('Ошибка dojo.extend (sickListWidget): '+e)
}

try {
    dojo.extend(dijit._Widget, {
        isOn: function() {
            var isOn = dojo.style(this.domNode, "display") != "none" && dojo.style(this.domNode, "visibility") != "collapse";
            return isOn
        },
        on: function() {
            this._setDisabledAttr(false);
            dojo.style(this.domNode, "display", "block");
            if (this.className() == 'dijit.form.CheckBox') {
                this.focus();
            }
            isDisabled(this);
        },
        off: function() {
            dojo.style(this.domNode, "display", "none");
            if (this.className() == 'dijit.form.CheckBox') {
                try {
                    this.attr('checked', false);
                } catch (e) {
                    //alert(e)
                }
            } else if (this.className() != 'dijit.form.FilteringSelect') {
                this.set('value', '');
            }
            this._setDisabledAttr(true);
        },
        className: function() {
            return this.attr('declaredClass');
        },
        setSlValue: function() {
            var dij = this;
            if (dij.hasOwnProperty('slValue')) {
                var slValue = dij.attr('slValue');
                if (slValue != "") {
                    if (this.className() == 'dijit.form.DateTextBox') {
                        //dij.set('value',new Date(slValue));
                        dij.set('value', new Date(slValue.replace(/(\d+)-(\d+)-(\d+)/, '$2/$3/$1')));//IE<8
                    } else if (this.className() == 'dijit.form.CheckBox') {
                        dij.set('checked', slValue == 'true');
                    } else if (this.className() == 'dijit.form.NumberTextBox' || this.className() == 'dijit.form.CurrencyTextBox') {
                        var value = (this.className() == 'dijit.form.CurrencyTextBox') ? parseFloat(slValue).toFixed(2) : slValue;
                        dij.set('value', value.replace('\.', ','));
                        dij.focus()
                    } else if (this.className() == 'dijit.form.RadioButton') {
                        dij.set('checked', (slValue == 'true'))
                    } else {
                        dij.set('value', slValue);
                    }
                } else {
                    dojo.hasClass(dij.domNode, 'workoutByMonth') ? dij.set('value', 0) : null
                }
            }
        }
    });
} catch (e) {
//alert('Ошибка dojo.extend (on|off): '+e)
}


//////////////////////////////////////////////////////////
var sumStart = '';
dojo.ready(function() {
    initDijits();
    setTimeout('sumStart=checkSum()', 200)
});


function initDijits() {
    try {
        dijit.registry.forEach(function(dij) {
            if (dij.hasOwnProperty('sickListWidget')) {
                //var changeEvent = (dij.className()!='dijit.form.Select')?'onChange':'onchange';
                var changeEvent = 'onChange';
                dojo.connect(dij, changeEvent, function() {
                    checkForm(dij)
                    dij.attr('slValue', '')
                });
                isDisabled(dij);
                dij.setSlValue();
                //checkForm(dij);
                if (dij.className() == 'dijit.form.FilteringSelect')
                    checkForm(dij);
            }
        });
    } catch (e) {
    }
    finally {
        if (!isModePrint)
            initTabs();
        checkForm(dijit.byId('openingDate'));
        checkIncomeOverdraft();
        changeYearAccounting2010Conditions();
        //rateChanged();
        checkForm(dijit.byId('rate'));
        if (mode == 'edit') {
            isFormValid();
        }
    }
}
//
function checkSum() {
    var sum = '';
    dijit.registry.forEach(function(dij) {
        if (dij.hasOwnProperty('sickListWidget')) {
            sum += dij.get('value')
        }
    })
    return sum;
}
//
function isDisabled(dij) {
    if (mode == 'view' || mode == 'print') {
        dij.set('disabled', true);
        if (dij.className() != 'dijit.form.RadioButton' && dij.className() != 'dijit.form.CheckBox') {
            dij.set('style', 'background:#fff');
            dij.set('style', 'border:1px solid #ccc');
            dij.set('style', 'color:#474747');
        }
    }
}

function checkForm(dij) {
    var id = dij.id;
    //var val = dij.get('slValue');
    var val = dij.get('value');
    switch (id) {
        //Tab1
        case 'openingDate':
            {
                openingDateChanged(id, val);
                break;
            }
        case 'closingDate':
            {
                closingDateChanged(id, val);
                break;
            }
        case 'typeOfDoc':
            {
                typeOfDocChanged(val);
                break;
            }
        case 'openingDatePrimary':
            {
                openingDatePrimaryChanged(id, val);
                break;
            }
        case 'primaryCalcMethod2010':
            {
                primaryCalcMethodChanged(dij.get('checked'));
                break;
            }
        case 'typeOfDisability':
            {
                typeOfDisabilityChanged(val);
                break;
            }
        case 'changeYearAccounting':
            {
                changeYearAccountingChanged(dij.get('checked'));
                break;
            }
        case 'changeYearAccounting2010':
            {
                (dij.isOn() == true) ? changeYearAccounting2010Changed(dij.get('checked')) : null
                break;
            }
        case 'additionalCategories':
            {
                additionalCategoriesChanged();
                break;
            }
        case 'ageOfTheChild':
            {
                ageOfTheChildChanged(val);
                break;
            }
        case 'regime':
            {
                if (dijit.byId('reduced').get('checked')) {
                    switchReduceReasons()
                }
                regimeChanged(val);
                break;
            }
        case 'mixedDaysSta':
            {
                mixedDaysStaChanged(val);
                break;
            }
        case 'mixedDaysAmb':
            {
                mixedDaysAmbChanged(val);
                break;
            }
            //Tab 2
        case 'rate':
            {
                rateChanged();
                break;
            }
        case 'hoursAtTheFullRate':
            {
                countRate();
                break;
            }
        case 'hoursAtTheNoFullRate':
            {
                countRate();
                break;
            }
        case 'reduced':
            {
                reducedChanged(dij.get('checked'));
                break;
            }
        case 'dateToReduce':
            {
                dateToReduceChanged(id, val);
                break;
            }
        case 'firstYear':
            {
                checkYears(id);
                setExceptedMax('firstExceptedDays',id)
                break;
            }
        case 'secondYear':
            {
                checkYears(id);
                setExceptedMax('secondExceptedDays',id)
                break;
            }
        case 'firstExceptedDays':
            {
                checkExceptedDays();
                break;
            }
        case 'secondExceptedDays':
            {
                checkExceptedDays();
                break;
            }            
    }
}
//

// Tab 1 controls behavior
function openingDateChanged(id, val) {
    if (checkDates(id)) {
        openingDate = val;
        if (!dijit.byId('closingDate').get('value') && mode != 'edit') {
            dijit.byId('closingDate').set('value', val)
            if (val)
                dijit.byId('closingDate').focus()
        }
        // switch series/number format
        if (val && val < DATE_OF_SEPARATION) {
            switchDijits('series,numberBeforeSeparation', true);
            switchDijits('numberAfterSeparation,changeYearAccounting,changeYearAccounting2010', false);
        } else {
            switchDijits('series,numberBeforeSeparation', false);
            switchDijits('numberAfterSeparation,changeYearAccounting,changeYearAccounting2010', true);
        }

        // switch conditions 2010/2011
        if (val && val < DATE_OF_YEAR_ACCOUNTING) {
            is2010Conditions = true
            //errDiv('openingDateChanged'+is2010Conditions)
            //errDiv('yo2010')
        } else {
            is2010Conditions = false
            //errDiv('openingDateChanged'+is2010Conditions)
            //errDiv('yo2010')
        }
        // switch primary/continuation 
        typeOfDocChanged(dijit.byId('typeOfDoc').get('value'));
        setCareYears();
        checkMixedDays();
        setAccountingYears();
        changeYearAccounting2010Conditions();
        typeOfDisabilityChanged(dijit.byId('typeOfDisability').get('value'));
        isExceptedDays();
        if (val)
            setMrot(val)
    } else {
        showErrMsg(errMsg);
    }
}
//
function formatDate(value)
{
    var dd = value.getDate();
    var mm = value.getMonth() + 1;
    mm = (mm < 10) ? '0' + mm : mm;
    var yyyy = value.getFullYear();
    return  dd + "." + mm + "." + yyyy;
}
//
function setMrot(fullDate) {
    if (!isPrimarySl()) {
        openingDatePrimary = dijit.byId('openingDatePrimary').get('value');
        fullDate = openingDatePrimary;
    }
    var mrot = getMrotByYear(fullDate);
    dijit.byId('mrot').set('value', mrot);
}

function isPrimarySl() {
    return dijit.byId('typeOfDoc').get('value') == DOC_TYPE_0;
}

function closingDateChanged(id, val) {
    if (checkDates(id)) {
        setCareYears();
        checkMixedDays();
    } else {
        showErrMsg(errMsg);
    }
}
//
function typeOfDocChanged(val) {
    switchBlock('primarySickListBlock', false);
    switchBlock('primarySickListBlockTopSeparator', false);
    switchBlock('primarySickListBlockBottomSeparator', false);
    if (val == DOC_TYPE_1) { //TODO remove hardcode '1'
        switchBlock('primarySickListBlockTopSeparator', true);
        switchBlock('primarySickListBlockBottomSeparator', true);
        switchBlock('primarySickListBlock', true);
        switchDijits('openingDatePrimary', true);
        openingDatePrimaryChanged(dijit.byId('openingDate').get('value'));
    } else {
        switchDijits('seriesPrimary,numberPrimaryBeforeSeparation,numberPrimaryAfterSeparation,openingDatePrimary', false);
    }
}
//
function openingDatePrimaryChanged(id, val) {
    openingDatePrimary = val;
    if (checkDates(id)) {
        // switch series/number format
        if (val && val >= DATE_OF_SEPARATION) {
            switchDijits('numberPrimaryAfterSeparation', true);
            switchDijits('seriesPrimary,numberPrimaryBeforeSeparation', false);
            //is2010Conditions = (dijit.byId("openingDatePrimary").get("value").getFullYear()=="2010")
        } else if (val && val <= DATE_OF_SEPARATION) {
            switchDijits('numberPrimaryAfterSeparation', false);
            switchDijits('seriesPrimary,numberPrimaryBeforeSeparation', true);
        }
        // switch conditions 2010/2011
        try {
            if (dijit.byId(id).isOn()) {
                if (val && val < DATE_OF_YEAR_ACCOUNTING) {

                    is2010Conditions = true

                    //errDiv('openingDatePrimaryChanged'+is2010Conditions)

                    //switchDijits('primaryCalcMethod2011',false);
                    dijit.byId('primaryCalcMethod2011').set('disabled', true);
                    dijit.byId('primaryCalcMethod2010').set('checked', true);

                    //if (typeOfDisability == DISABILITY_TYPE_1)
                    if (typeOfDisability == DISABILITY_TYPE_0 || typeOfDisability == DISABILITY_TYPE_1)
                        switchDijits('changeYearAccounting,changeYearAccounting2010', false);
                } else {
                    is2010Conditions = false
                    //errDiv('openingDatePrimaryChanged'+is2010Conditions)
                    dijit.byId('primaryCalcMethod2011').set('disabled', false);
                    switchDijits('primaryCalcMethod2011', true);
                    //dijit.byId('primaryCalcMethod2010').set('checked',true);
                    //if (typeOfDisability == DISABILITY_TYPE_1)
                    if (typeOfDisability == DISABILITY_TYPE_0 || typeOfDisability == DISABILITY_TYPE_1)
                        switchDijits('changeYearAccounting,changeYearAccounting2010', true);
                    setAccountingYears();
                }
            }
        } catch (e) {
        }
        changeYearAccounting2010Conditions()
        if (val)
            setMrot(val)
    } else {
        showErrMsg(errMsg);
    }
}
//
function primaryCalcMethodChanged(isChecked) {
    if (dijit.byId('openingDate').get('value') > DATE_OF_YEAR_ACCOUNTING) {
        //is2010Conditions = !isChecked;
    }
    //errDiv('primaryCalcMethodChanged'+is2010Conditions)

    changeYearAccounting2010Conditions();
}
//
function typeOfDisabilityChanged(val) {
    typeOfDisability = val;
    switchDijits('regime', true);
    switchDijits('regimeAmb', false);
    switchDijits('regimeSta', false);
    switchDijits('changeYearAccounting', false);
    switchDijits('changeYearAccounting2010', false);
    switchDijits('ageOfTheChild', false);
    switchDijits('additionalCategories', false);
    switchDijits('leftDays,useDays', false);
    switchBlock('careDaysBlock', false);
    switchBlock('careDaysBlockTopSeparator', false);
    switchBlock('careDaysBlockBottomSeparator', false);

    //if (val == DISABILITY_TYPE_1) {
    if (val == DISABILITY_TYPE_0 || val == DISABILITY_TYPE_1) {
        if (openingDate >= DATE_OF_YEAR_ACCOUNTING) {
            switchDijits('changeYearAccounting', true);
            var isChecked = dijit.byId('changeYearAccounting').get('checked');
            if (isChecked) {
                switchDijits('changeYearAccounting2010', false);
            } else {
                switchDijits('changeYearAccounting', true);
                switchDijits('changeYearAccounting2010', true);
                dijit.byId('changeYearAccounting').setSlValue();
                dijit.byId('changeYearAccounting2010').setSlValue();
            }
            setAccountingYearsState(isChecked);
        } else {
            switchDijits('changeYearAccounting,changeYearAccounting2010', false)
        }
    } else {
        switchDijits('changeYearAccounting,changeYearAccounting2010', false)
    }

    if (val == DISABILITY_TYPE_2) {
        switchDijits('ageOfTheChild', true);
        switchDijits('additionalCategories', true);
        setCareYears();
        //switchDijits('useDays',true);
    }

    isExceptedDays();
}
//
function changeYearAccountingChanged(isChecked) {
    setAccountingYearsState(isChecked);
//changeAccountingType('changeYearAccounting',isChecked);
}
//
function changeAccountingType(id, isChecked) {
    //if (openingDate >= DATE_OF_YEAR_ACCOUNTING && dijit.byId('typeOfDisability').get('value') == DISABILITY_TYPE_1) {
    if (openingDate >= DATE_OF_YEAR_ACCOUNTING && (dijit.byId('typeOfDisability').get('value') == DISABILITY_TYPE_0 || dijit.byId('typeOfDisability').get('value') == DISABILITY_TYPE_1)) {
        if (id == 'changeYearAccounting') {
            if (isChecked) {
                switchDijits('changeYearAccounting2010', false);
            } else {
                switchDijits('changeYearAccounting2010', true);
            }
        }

        if (id == 'changeYearAccounting2010') {
            if (isChecked) {
                switchDijits('changeYearAccounting', false);
            } else {
                switchDijits('changeYearAccounting', true);
            }
        }
    }

    /*
     if(openingDatePrimary && openingDatePrimary < DATE_OF_YEAR_ACCOUNTING || is2010Conditions){
     switchDijits('changeYearAccounting,changeYearAccounting2010',false)
     }
     */
}
//
function changeYearAccounting2010Changed(isChecked) {
    if (openingDate >= DATE_OF_YEAR_ACCOUNTING) {
        is2010Conditions = isChecked;

        //errDiv('changeYearAccounting2010Changed'+is2010Conditions)

        changeYearAccounting2010Conditions();
    }
}
//

function changeYearAccounting2010Conditions() {
    dijit.byId('primaryCalcMethodOld').set('checked', is2010Conditions)
    if (is2010Conditions) {

        switchBlock('yearsAccHeaderBlock,employersBlock,addNewEmployerBlock,yearsAccFooterBlock,maxIncomes', false);
        switchDijits('rate,hoursAtTheFullRate,hoursAtTheNoFullRate', false);
        //switchDijits('rateType,benefitAmount,mixedTaxes,insuranceLess6Months',true);
        switchDijits('rateType,benefitAmount,mixedTaxes', true);
        dijit.byId('mixedTaxes').setSlValue();
        switchBlock('calc2010AmountBlock,calcConditions2010', true);
        //if (typeOfDisability == DISABILITY_TYPE_1)
        if (typeOfDisability == DISABILITY_TYPE_0 || typeOfDisability == DISABILITY_TYPE_1)
        {
            switchDijits('changeYearAccounting', false);
        }
    } else {
        switchDijits('rate,hoursAtTheFullRate,hoursAtTheNoFullRate', true);
        //switchDijits('rateType,benefitAmount,mixedTaxes,insuranceLess6Months',false);
        switchDijits('rateType,benefitAmount,mixedTaxes', false);
        switchBlock('yearsAccHeaderBlock,employersBlock,addNewEmployerBlock,yearsAccFooterBlock,maxIncomes', true);
        switchBlock('calc2010AmountBlock,calcConditions2010', false);
        //if (typeOfDisability == DISABILITY_TYPE_1) {
        if (typeOfDisability == DISABILITY_TYPE_0 || typeOfDisability == DISABILITY_TYPE_1) {
            switchDijits('changeYearAccounting,changeYearAccounting2010', true)
            dijit.byId('changeYearAccounting').setSlValue()

            if (!dijit.byId('changeYearAccounting').get('checked')) {
                dijit.byId('changeYearAccounting2010').setSlValue()
            } else {
                switchDijits('changeYearAccounting2010', false)
            }
            if (!dijit.byId('changeYearAccounting2010').get('checked')) {
                dijit.byId('changeYearAccounting').setSlValue()
            } else {
                switchDijits('changeYearAccounting', false)
            }
        }
    }
}


function setAccountingYearsState(isChecked) {
    var f = dijit.byId('firstYear');
    var s = dijit.byId('secondYear');
    if (isChecked && mode != 'view' && mode != 'print') {
        f.set('readOnly', false);
        s.set('readOnly', false);
        f.set('readOnly', false);
        s.set('readOnly', false);
    } else {
        //if(!dijit.byId('changeYearAccounting').get('slValue'))f.set('value',MAX_FIRST_YEAR);
        if (!dijit.byId('changeYearAccounting').get('slValue'))
            setAccountingYears();
        f.set('readOnly', true);
        //if(!dijit.byId('changeYearAccounting').get('slValue'))s.set('value',MAX_SECOND_YEAR);
        s.set('readOnly', true);
    }

//errDiv('f='+f.get('value'))
//errDiv('s='+s.get('value'))
}
//
function regimeChanged(val) {
    switchBlock('mixedRegimeBlockTopSeparator', false);
    switchBlock('mixedRegimeBlockBottomSeparator', false);
    switchBlock('mixedRegimeBlock', false);
    switchDijits('mixedDaysAmb,mixedDaysSta', false);
    if (val == REGIME_2) {
        switchBlock('mixedRegimeBlockTopSeparator', true);
        switchBlock('mixedRegimeBlockBottomSeparator', true);
        switchBlock('mixedRegimeBlock', true);
        switchDijits('mixedDaysAmb,mixedDaysSta', true);
    }
}
//
function mixedDaysStaChanged() {
    checkMixedDays();
}
//
function mixedDaysAmbChanged() {
    checkMixedDays();
}
//
function checkMixedDays() {
    if (dijit.byId('regime').get('value') == REGIME_2) {
        var openingDate = dijit.byId('openingDate').get('value');
        var closingDate = dijit.byId('closingDate').get('value');
        var daysDiff;
        if (openingDate && closingDate) {
            daysDiff = ((closingDate.getTime() - openingDate.getTime()) / 1000 / 60 / 60 / 24) + 1;
        }
        var daysTotal;
        var mixedDaysAmb = dijit.byId('mixedDaysAmb').get('value');
        var mixedDaysSta = dijit.byId('mixedDaysSta').get('value');
        if (mixedDaysAmb && mixedDaysAmb) {
            daysTotal = mixedDaysAmb + mixedDaysSta;
        }
        if (daysDiff && daysTotal && (daysTotal) != daysDiff) {
            dijit.byId('mixedDaysAmb').set('value', '');
            dijit.byId('mixedDaysSta').set('value', '');
            showErrMsg(INCORRECT_MIXED_DAYS);
        }
    }
}
//
function setAccountingYears() {
    //if(mode!="view" && mode!="print" && mode!="edit"){
    if (mode == "new" || !dijit.byId('changeYearAccounting').get('slValue')) {
        if (isPrimarySl()) {
            var yearOpening = (dijit.byId('openingDate').get('value') != null) ? dijit.byId('openingDate').get('value').getFullYear() : null;
        } else {
            var yearOpening = (dijit.byId('openingDatePrimary').get('value') != null) ? dijit.byId('openingDatePrimary').get('value').getFullYear() : null;
        }
        if (yearOpening) {
            var newFirstYear = parseInt(yearOpening) - 2;
            var newSecondYear = parseInt(yearOpening) - 1;
            dijit.byId('firstYear').set('value', newFirstYear)
            dijit.byId('secondYear').set('value', newSecondYear)
        }
    }
}
//
function setRegime(regime) {
    switchDijits('regime,regimeAmb,regimeSta,regimeAmbSta', false);
    switchDijits(regime, true);
}
//
function additionalCategoriesChanged() {
    var addCat = dijit.byId('additionalCategories').get('value');
    var regime = 'regime'; //default - all
    dijit.byId('ageOfTheChild').set('required', false);
    var ageOfTheChild = parseInt(dijit.byId('ageOfTheChild').get('value'));

    if (addCat == ADDITIONAL_CAT_1) {
        if (!ageOfTheChild) {
            regime = 'regimeAmb'
        }
    } else if (addCat == ADDITIONAL_CAT_2 || addCat == ADDITIONAL_CAT_3 || addCat == ADDITIONAL_CAT_3 || addCat == ADDITIONAL_CAT_4) {
        if (!ageOfTheChild) {
            dijit.byId('ageOfTheChild').set('value', '');
            dijit.byId('ageOfTheChild').set('required', true);
        }
        if (addCat == ADDITIONAL_CAT_3) {
            regime = 'regimeSta'
        }
    }
    setRegime(regime);
}
//
function ageOfTheChildChanged(val) {
    additionalCategoriesChanged()

    if (dijit.byId('reduced').get('checked')) {
        switchReduceReasons()
    }
}
//
function setCareYears() {
    var openingDate = dijit.byId('openingDate').get('value');
    var closingDate = dijit.byId('closingDate').get('value');
    var typeOfDisability = dijit.byId('typeOfDisability').get('value');
    if (openingDate != null && closingDate != null && typeOfDisability == ADDITIONAL_CAT_2) {
        var openingYear = openingDate.getFullYear();
        var closingYear = closingDate.getFullYear();
        switchBlock('careDaysBlock', true);
        switchBlock('careDaysBlockTopSeparator', true);
        switchBlock('careDaysBlockBottomSeparator', true);
        switchDijits('useDays', true);
        dijit.byId('useDays').setSlValue()
        if (openingYear < closingYear) {
            switchDijits('leftDays', true);
            dijit.byId('leftDays').setSlValue()
            dojo.byId('leftDaysYear').innerHTML = openingYear;
        } else {
            switchDijits('leftDays', false);
        }
        dojo.byId('useDaysYear').innerHTML = closingYear;
    }
}

// Tab 2 controls behavior
function rateChanged() {
    if (!is2010Conditions) {
        var rate = parseFloat(dijit.byId('rate').get('value'))
        if (rate && rate > 0) {
            switchDijits('hoursAtTheFullRate,hoursAtTheNoFullRate', false);
        } else {
            switchDijits('hoursAtTheFullRate,hoursAtTheNoFullRate', true);
        }
    }
}
//
function countRate() {
    var full = dijit.byId('hoursAtTheFullRate').get('value');
    var partial = dijit.byId('hoursAtTheNoFullRate').get('value');
    if (full && !partial) {
        dijit.byId('hoursAtTheNoFullRate').set('required', true)
        dijit.byId('hoursAtTheNoFullRate').focus()
    } else if (!full && partial) {
        dijit.byId('hoursAtTheFullRate').set('required', true)
        dijit.byId('hoursAtTheNoFullRate').focus()
    } else if (!full && !partial) {
        dijit.byId('hoursAtTheFullRate').set('required', false)
        dijit.byId('hoursAtTheNoFullRate').set('required', false)
    } else if (full && partial) {
        var rate = (parseInt(partial) / parseInt(full)).toFixed(2).replace('.', ',')
        dijit.byId('rate').set('value', rate)
    }
}
//
function reducedChanged(isChecked) {
    switchDijits('dateToReduce,violation,absence,alco', false);
    if (isChecked) {
        switchBlock('reducedReasons', true);
        switchReduceReasons()
        dijit.byId('dateToReduce').set('required', true);
        dijit.byId('dateToReduce').setSlValue();
        if (dijit.byId('dateToReduce').get('value') == null) {
            dijit.byId('dateToReduce').focus();
        }
        dijit.byId('violation').setSlValue();
        dijit.byId('absence').setSlValue();
        dijit.byId('alco').setSlValue();
    } else {
        switchBlock('reducedReasons', false);
        dijit.byId('violation').attr('slValue', '');
        dijit.byId('absence').attr('slValue', '');
        dijit.byId('alco').attr('slValue', '');
        dijit.byId('reduced').set('checked', false);
        dijit.byId('dateToReduce').attr('slValue', '');
    }
}
//
function switchReduceReasons() {
    switchDijits('violation,absence,alco', false);
    var typeOfDisability = dijit.byId('typeOfDisability').get('value');
    var ageOfTheChild = dijit.byId('ageOfTheChild').get('value');
    var regime = dijit.byId('regime').get('value');
    if (typeOfDisability == DISABILITY_TYPE_2 && ageOfTheChild && ageOfTheChild > 0) {
        if (regime == REGIME_1) {
            switchDijits('dateToReduce,violation', true);
        } else {
            switchDijits('dateToReduce,violation,absence', true);
        }
    } else {
        switchDijits('dateToReduce,violation,absence,alco', true);
    }
}

//
function dateToReduceChanged(id, val) {
    if (!checkDates(id)) {
        showErrMsg(errMsg);
    }
}

// Common actions
function switchBlock(blockList, state) {
    var blocks = blockList.split(',');
    for (i = 0; i < blocks.length; i++) {
        var block = dojo.byId(blocks[i]);
        if (state) {
            if (block)
                dojo.removeClass(block, 'off');
        } else {
            if (block)
                dojo.addClass(block, 'off');
        }
    }
}
//
function switchDijits(dijList, state) {
    var dijs = dijList.split(',');
    for (i = 0; i < dijs.length; i++) {
        var label = dojo.query("label[for=" + dijs[i] + "]")[0];// TODO maybe multiply labels
        var dij = dijit.byId(dijs[i]);
        if (state) {
            dij.on();
            if (label)
                dojo.removeClass(label, 'off');
        } else {
            dij.off();
            if (label)
                dojo.addClass(label, 'off');
        }

    }
}
//
function addEmployer() {
    var employersCount = parseInt(dijit.byId('employersCount').get('value'));
    dijit.byId('employersCount').set('value', parseInt(employersCount) + 1);

    var newEmployerBlock = '';
    newEmployerBlock += '<tr>';
    newEmployerBlock += '<td colspan="2" class="fieldTitle" nowrap><a onClick="removeEmployer(this)" title="Удалить работодателя"><img src="' + ico + '/document_delete.png" width="16" height="16" border="0"></a><div class="nbNumber" class="nbNumber">Работодатель ' + employersCount + '</div></td>';
    newEmployerBlock += '<td class="right"><input name="firstIncome_' + employersCount + '" dojoType="dijit.form.CurrencyTextBox" sickListWidget class="myField firstIncomeField" onchange="countFirstIncome()"/></td>';
    newEmployerBlock += '<td class="right"><input name="secondIncome_' + employersCount + '" dojoType="dijit.form.CurrencyTextBox" sickListWidget class="myField secondIncomeField" onchange="countSecondIncome()"/></td>';
    newEmployerBlock += '</tr>';

    try {
        dojo.place(newEmployerBlock, "employersBlock", 'last');
        dojo.parser.parse("myForm");
    } catch (e) {
        // alert(e)
    }
}
//
function removeEmployer(btn) {
    var tNB = btn.parentNode.parentNode;
    var widgets = dijit.findWidgets(tNB);
    dojo.forEach(widgets, function(w) {
        w.destroyRecursive(true);
    });
    dojo.destroy(tNB);
    var nbsNew = parseInt(dijit.byId('employersCount').get('value')) - 1;
    dijit.byId('employersCount').set('value', nbsNew);
    refreshEmployers();
}
//
function refreshEmployers() {
    // renew titles
    var k = 1;
    dojo.query("div.nbNumber").forEach(function(d) {
        if (d.parentNode.parentNode.id != 'mainEmployer') {
            d.innerHTML = 'Работодатель ' + k;
            k++;
        }
    });
    // renew widgets
    dojo.query("#employersBlock tr").forEach(function(tNB, index) {
        dojo.query('input[type=hidden]', tNB).forEach(function(ele) {
            //errDiv('renaming: '+ele.name)
            var newName = (ele.name).split('_')[0] + '_' + index;
            ele.name = newName;
            //errDiv('new name: '+ele.name)
            //errDiv('<br>')
        });
    });
    countFirstIncome();
    countSecondIncome()
}
//
function countFirstIncome() {
    var firstMaxIncome = parseFloat(dijit.byId('firstMaxIncome').get('value'));
    var total = parseFloat(0);
    dojo.query('.firstIncomeField').forEach(function(node) {
        var dij = dijit.byNode(node);
        var floatInc = parseFloat(dij.get('value'));
        if (floatInc) {
            total = total + floatInc;
        }
    });
    dijit.byId('firstRealIncome').set('value', total);
    checkIncomeOverdraft();
}
//
function countSecondIncome() {
    var total = parseFloat(0);
    dojo.query('.secondIncomeField').forEach(function(node) {
        var dij = dijit.byNode(node);
        var floatInc = parseFloat(dij.get('value'));
        if (floatInc) {
            total = total + floatInc;
        }
    });
    dijit.byId('secondRealIncome').set('value', total);
    checkIncomeOverdraft();
}
//
function checkIncomeOverdraft() {
    var firstRealIncome = dijit.byId('firstRealIncome').get('value');
    var firstMaxIncome = dijit.byId('firstMaxIncome').get('value');

    if (firstMaxIncome && firstRealIncome > firstMaxIncome) {
        dojo.addClass('firstRealIncome', 'incomeOverdraft');
    } else {
        dojo.removeClass('firstRealIncome', 'incomeOverdraft');
    }
    var secondRealIncome = dijit.byId('secondRealIncome').get('value');
    var secondMaxIncome = dijit.byId('secondMaxIncome').get('value');

    if (secondMaxIncome && secondRealIncome > secondMaxIncome) {
        dojo.addClass('secondRealIncome', 'incomeOverdraft');
    } else {
        dojo.removeClass('secondRealIncome', 'incomeOverdraft');
    }
}
//
//
function nextTab() {
    if (activeTab < 2) {
        switchTab(activeTab + 1);
    }
}
//
function resetFields(fieldList) {
    try {
        var fields = fieldList.split(',');
        for (i = 0; i < fields.length; i++) {
            try {
                dijit.byId(fields[i]).set('value', '');
            } catch (e) {
                //errDiv(e,'red');
            }
        }
    } catch (e) {
        //errDiv(e)
    } finally {
        hideErrMsg();
    }
}
//
function checkDates(id) {
    var openingDate = dijit.byId('openingDate').get('value');
    var closingDate = dijit.byId('closingDate').get('value');
    var openingDatePrimary = dijit.byId('openingDatePrimary').get('value');
    var dateToReduce = dijit.byId('dateToReduce').get('value');

    if (id != null) {
        //
        if (openingDate != null && openingDate < new Date(2009, 01, 01)) {
            errMsg = "Невозможно выполнить расчет для данного года";
            dijit.byId('openingDate').set('value', '');
            return false;
        }
        //
        if (openingDate != null && openingDate > new Date(CURRENT_YEAR, 11, 31)) {
            errMsg = "Дата открытия должна быть не больше текущего года";
            dijit.byId('openingDate').set('value', '');
            return false;
        }
        //
        if (openingDate != null && closingDate != null && openingDate > closingDate) {
            errMsg = "Дата открытия должна быть меньше даты закрытия";
            //advOpts="<button dojoType=\"dijit.form.Button\" class=\"myButton\" onclick='resetFields(\"openingDate,closingDate\")'>Обнулить даты</button>"
            if (id == 'openingDate') {
                dijit.byId('openingDate').set('value', '');
            }
            if (id == 'closingDate') {
                dijit.byId('closingDate').set('value', '');
            }
            return false;
        }
        //
        if (openingDate != null && openingDatePrimary != null && openingDate < openingDatePrimary) {
            errMsg = "Дата открытия первичного листка должна быть меньше даты открытия основного";
            //advOpts="<button dojoType=\"dijit.form.Button\" class=\"myButton\" onclick='resetFields(\"openingDate\")'>Обнулить даты</button>"
            if (id == 'openingDate') {
                dijit.byId('openingDate').set('value', '');
            }
            if (id == 'openingDatePrimary') {
                dijit.byId('openingDatePrimary').set('value', '');
            }
            return false;
        }
        //
        if (dateToReduce != null && openingDate != null && openingDate > dateToReduce) {
            if (id == 'openingDate') {
                //errMsg = "Дата снижения пособия не может быть меньше даты открытия. Введите заново дату открытия и данные по снижению пособия.";
                errMsg = "Дата снижения пособия не может быть меньше даты открытия. Введите заново данные по снижению пособия.";
                //dijit.byId('openingDate').set('value','');
                reducedChanged(false);
            }
            if (id == 'dateToReduce') {
                errMsg = "Дата снижения пособия не может быть меньше даты открытия.";
                dijit.byId('dateToReduce').set('value', '');
            }
            return false;
        }
        //
        if (dateToReduce != null && closingDate != null && closingDate < dateToReduce) {
            if (id == 'closingDate') {
                errMsg = "Дата снижения пособия не может быть больше даты закрытия. Введите заново дату закрытия и данные по снижению пособия.";
                dijit.byId('closingDate').set('value', '');
                reducedChanged(false);
            }
            if (id == 'dateToReduce') {
                errMsg = "Дата снижения пособия не может быть больше даты закрытия.";
                dijit.byId('dateToReduce').set('value', '');
            }
            return false;
        }
        return true;
    }
    return false;
}
//
//var errDialog;
var errMsg = "";
var advOpts = "";
//
function showErrMsg(errMsg, advOptions) {
    if (!advOpts) {
        advOpts = "";
    }
    if (errMsg != '') {
        var params = {
            title: "Ошибка",
            content: '<div class="errMsg">' + errMsg + '</div>' + '<div class="center noWrap">' + advOpts +
                    '<button dojoType="dijit.form.Button" class="myButton" onclick="hideErrMsg()" style="margin-left:4px !important">Закрыть</button></div>'
        }
        //if (errDialog == null)
        errDialog = new dijit.Dialog(params);
        errDialog.show();

        errMsg = '';
        advOptions = '';
    }
//errMsg = '';
//advOptions = '';
}
//
function hideErrMsg() {
    errMsg = '';
    //advOptions = '';
    errDialog.hide();
//errDialog.orphan();
//var dialog = dijit.getEnclosingWidget(el.domNode.parentNode);
//dialog.hide();
}
//
function checkYears(id) {
    var firstYear = dijit.byId('firstYear').get('value');
    var secondYear = dijit.byId('secondYear').get('value');

    if (firstYear != '' && secondYear != '') {
        if (firstYear >= secondYear) {
            errMsg = "Первый год должен быть меньше второго"
            dij = dijit.byId(id);
            dij.set('value', '');
            showErrMsg(errMsg);
        }
    }
    switchMaxIncomes(id, firstYear, secondYear);
}
//
function switchMaxIncomes(id, firstYear, secondYear) {
    var dij = dijit.byId(id);
    var dij1 = dijit.byId('firstMaxIncome');
    var dij2 = dijit.byId('secondMaxIncome');
    var max = 0;

    if (dij.get('value') >= 2009) {
        //max = eval('MAX_YEAR_INCOME_'+dij.get('value'));
        max = getMaxYearIncomeByYear("01.01." + dij.get('value'));
    }

    switch (id) {
        case 'firstYear':
            {
                dij1.set('value', max)
                break
            }
        case 'secondYear':
            {
                dij2.set('value', max)
                break
            }
    }

    dojo.style(dij1.domNode, 'display', (firstYear < 2009) ? 'none' : 'block')
    dojo.style(dij2.domNode, 'display', (secondYear < 2009) ? 'none' : 'block')
    dojo.style('maxIncomes', 'visibility', (firstYear < 2009 && secondYear < 2009 || is2010Conditions) ? 'collapse' : 'visible')

    checkIncomeOverdraft()
}
//
function calcSave() {
    if (isFormValid()) {
        try {
            dojo.byId("is2010Algorithm").value = is2010Conditions;
        } catch (e) {
            //errDiv(e,red)
        } finally {
            var xhrArgs = {
                form: dojo.byId("myForm"),
                handleAs: 'json',
                preventCache: true,
                load: function(data) {
                    dijit.byId("days").set("value", data.days);
                    dijit.byId("benifits").set("value", data.benifits);
                    dijit.byId("fund").set("value", data.fund);
                    dijit.byId("insurer").set("value", data.insurer);
                    switchTab(2);
                    //                    errDiv(data.days)
                    //                    errDiv(data.benifits)
                    //                    errDiv(data.fund)
                    //                    errDiv(data.insurer)
                    sumStart = checkSum();
                    if (data.errMsg) {
                        showErrMsg(data.errMsg)
                    }
                },
                error: function(error) {
                    //errDiv(error)
                }
            }
            dojo.xhrPost(xhrArgs);
        }
    }
}
//
function errDiv(val, color) {
    var style = ""
    if (color) {
        style = 'style={color:' + color + '}';
    }
    try {
        var errDiv = dojo.byId('errDiv')
        errDiv.innerHTML += '<div ' + style + '>' + val + '</div>';
    }
    catch (e) {
    }
}
//
function initTabs() {
    if (isTabs) {
        dojo.query('.headertabs>ul>li').forEach(function(tab, index) {
            dojo.connect(tab, 'onclick', function() {
                switchTab(index);
            })
        });
        var firstTab = dojo.query('.headertabs > ul > li')[0];
        var firstContent = dojo.query('.tabContent > div')[0];
        dojo.addClass(firstTab, 'selected-tab');
        dojo.addClass(firstContent, 'tabContentActive');
        activeTab = 0;
    }
}
//
function isFormValid() {
    var isFormValid = true;
    for (i = 0; i < 3; i++) {
        if (!isTabValid(i)) {
            switchTab(i);
            return false;
        }
    }
    return isFormValid;
}

//
function isTabValid(tabId) {
    var isTabValid = true;
    var currTabContent = dojo.query('#tabContent > div')[parseInt((tabId) ? tabId : activeTab)];
    var dijs = dojo.query("[sickListWidget=]", currTabContent).map(dijit.byNode);//IE
    var firstErrDij;
    var errDijits = new Array();

    try {
        if (is2010Conditions && activeTab == 1)
            isTabValid = isWorkoutsValid();
        if (tabId == 1 && activeTab == 1) {
        //if (tabId == 1) {
            if (dijit.byId('reduced').get('checked')) {
                var isAlco = dijit.byId('alco').get('checked');
                var isAbsent = dijit.byId('absence').get('checked');
                var isViolation = dijit.byId('violation').get('checked');
                if (!isAlco && !isViolation && !isAbsent) {
                    isTabValid = false;
                    errMsg = 'Должно быть заполнено одно из трёх полей:<ul style="display:block;margin:4px 4px 4px 20px;text-align:left;"><li>Нарушение режима, предписанного врачом<li>Неявка на прием или на проведение МСЭ<li>Заболевание или травма вследствие опьянения</ul>';
                    showErrMsg(errMsg);
                }
            }
        }
    } catch (e) {
    }

    finally {
        dojo.forEach(dijs, function(dij) {
            try {
                if (dij.isOn() && !dij.isValid()) {
                    dij.set("state", "Error");
                    dij._setStateClass();
                    errDijits.push(dij)
                    isTabValid = false;
                }
            } catch (e) {
            }
        });

        if (errDijits.length > 0) {
            firstErrDij = errDijits[0];
            firstErrDij.displayMessage(firstErrDij.getErrorMessage());
        }
        return isTabValid;
    }
}
//
function isWorkoutValid(wN) {
    var pm = dijit.byId('paymentMonth' + wN).get('value')
    var wm = dijit.byId('workoutMonth' + wN).get('value')
    if ((isNaN(wm) && pm > 0) || (pm > 0 && !wm > 0)) {
        dij = dijit.byId('workoutMonth' + wN);
        dij.set('required', isNaN(pm))
        dij.set("state", "Error");
        dij._setStateClass()
        return false
    }
    return true
}

function isWorkoutsValid() {
    var isValid = true;
    for (i = 1; i < 13; i++) {
        (isWorkoutValid(i) == false) ? isValid = false : null
    }
    return isValid;
}

//
function switchTab(tabIndex) {
    if (isTabValid()) {
        dojo.query('.headertabs > ul > li').forEach(function(tab, index) {
            if (tabIndex != index) {
                dojo.removeClass(tab, 'selected-tab');
            } else {
                dojo.addClass(tab, 'selected-tab');
            }
        });

        dojo.query('.tabContent > div').forEach(function(div, index) {
            if (tabIndex != index) {
                dojo.removeClass(div, 'tabContentActive');
            } else {
                dojo.addClass(div, 'tabContentActive');
            }
        });
        //
        activeTab = tabIndex;
        if (activeTab == 2) {
            dijit.byId('btnNext').set('disabled', true);
        } else {
            dijit.byId('btnNext').set('disabled', false);
        }
    }
}

//
function print(loc) {
    isCalcDone = sumStart == checkSum();
    if (isCalcDone) {
        try {
            var win = window.open(loc, 'printWindow');
            if (win.window.focus)
            {
                win.window.focus();
            }
        } catch (e) {
            //alert(e);
        }
    } else {
        var errMsg = "Данные были изменены. Печать формы будет доступна только после проведения расчета.";
        showErrMsg(errMsg)
    }
    ;
}

// 
function getMaxYearIncomeByYear(fullDate) {
    return parseFloat(maxIncomes[fullDate.toString()])
}


function getMrotByYear(fullDate) {
    var mrot = 0;
    forEachJson(mrotz, function(key, value) {
        var aDate = key.split(".");
        var dd = aDate[0]
        var MM = aDate[1] - 1
        var yyyy = aDate[2]
        var keyAsDate = new Date(yyyy, MM, dd);
        //errDiv(keyAsDate,"red")
        //errDiv(fullDate,"blue")
        if (fullDate >= keyAsDate) {
            mrot = value;
        }
    }
    )
    return mrot;
//return mrotz[fullDate.toString()]

}
//
function forEachJson(data, callback) {
    for (var key in data) {
        if (data.hasOwnProperty(key)) {
            callback(key, data[key]);
        }
    }
}
//
//
function daysInYear(year) {
    if(year % 4 === 0 && (year % 100 !== 0 || year % 400 === 0)) {
        return 366;
    } else {
        return 365;
    }
}
//
function setExceptedMax(excYearId,yearId){
    var year = dijit.byId(yearId).get('value');
    var constr = {places:0,min:0,max:daysInYear(year)};
    dijit.byId(excYearId).set('constraints',constr)    
}
//
function isExceptedDays() {
    var isExceptedDays = (dijit.byId('openingDate').get('value') && dijit.byId('openingDate').get('value') >= DATE_OF_EXCEPTION && dijit.byId('typeOfDisability').get('value') == DISABILITY_TYPE_1);
    dijit.byId("firstExceptedDays").set('disabled', !isExceptedDays)
    dijit.byId("secondExceptedDays").set('disabled', !isExceptedDays)
    if (!isExceptedDays) {
        dijit.byId("firstExceptedDays").set('value', '0');
        dijit.byId("secondExceptedDays").set('value', '0');
    }
}
//
function checkExceptedDays(){
    var exc1 = dijit.byId('firstExceptedDays').get('value');
    var exc1max = dijit.byId('firstExceptedDays').get('constraints').max;
    var exc2 = dijit.byId('secondExceptedDays').get('value');
    var exc2max = dijit.byId('secondExceptedDays').get('constraints').max;
    if((exc1 +exc2)==(exc1max+exc2max)){
        dijit.byId('exceptedAchievedDialog').show()
        if(dijit.byId('formBtn0'))dijit.byId('formBtn0').set('disabled',true);
    } else {
        if(dijit.byId('formBtn0'))dijit.byId('formBtn0').set('disabled',false);
    }
}
//